// Copyright Notice
// ================
// BOCHS is Copyright 1994,1995,1996,1997,1998 by Kevin P. Lawton.
// 
// BOCHS is commercial software.
// 
// For more information, read the file 'LICENSE' included in the bochs
// distribution.  If you don't have access to this file, or have questions
// regarding the licensing policy, the author may be contacted via:
// 
//     US Mail:  Kevin Lawton
//               528 Lexington St.
//               Waltham, MA 02154
// 
//     EMail:    bochs@world.std.com






#include "bochs.h"





/* The 16bit code part of decode_exgx() was rewritten to use a
 * giant switch statement for efficiency.  The 32bit code, after
 * testing, should also be rewritten as such.
 * ???
 */

/* reg_index should be of type unsigned, along with rm_type */


  void
bx_cpu_c::decode_exgx(void)
{
#if BX_CPU > 2
  if (BX_CPU_THIS_PTR is_32bit_addrsize) {
    Bit8u  mod, ttt, rm, sib, ss, index, base;
    Bit32u displ32, index_reg_val, base_reg_val;
    Bit8u  modrm;
    Bit8u  displ8;

    /* NOTES:
     * seg_reg_mod01_base & mod10_base aren't correct???
     */
    /* use 32bit addressing modes.  orthogonal base & index registers,
       scaling available, etc. */
    modrm = fetch_next_byte();
    rm  = modrm & 0x07; modrm >>= 3;
    ttt = modrm & 0x07; modrm >>= 3;
    mod = modrm;

    BX_CPU_THIS_PTR modrm_ttt = ttt;

    BX_CPU_THIS_PTR reg_index = ttt;
    if (mod == 3) { /* mod, reg, reg */
      BX_CPU_THIS_PTR rm_addr = rm;
      BX_CPU_THIS_PTR rm_type = BX_REGISTER_REF;
#if BX_WEIRDISMS
      BX_CPU_THIS_PTR rm_seg_reg = NULL;
#endif
      }
    else { /* mod != 3 */
      BX_CPU_THIS_PTR rm_type = BX_MEMORY_REF;
      if (rm != 4) { /* rm != 100b, no s-i-b byte */
        /* one byte modrm */
        switch (mod) {
          case 0:
            if (BX_CPU_THIS_PTR segment_override)
              BX_CPU_THIS_PTR rm_seg_reg = BX_CPU_THIS_PTR segment_override;
            else
              BX_CPU_THIS_PTR rm_seg_reg = & BX_CPU_THIS_PTR ds;
            if (rm == 5) { /* no reg, 32-bit displacement */
              BX_CPU_THIS_PTR rm_addr = fetch_next_dword();
              }
            else {
              /* else reg indirect, no displacement */
              BX_CPU_THIS_PTR rm_addr = BX_READ_32BIT_REG(rm);
              }
            break;
          case 1:
            if (BX_CPU_THIS_PTR segment_override)
              BX_CPU_THIS_PTR rm_seg_reg = BX_CPU_THIS_PTR segment_override;
            else
              BX_CPU_THIS_PTR rm_seg_reg = BX_CPU_THIS_PTR sreg_mod01_rm32[rm];
            /* reg, 8-bit displacement, sign extend */
            displ8 = fetch_next_byte();
            BX_CPU_THIS_PTR rm_addr = BX_READ_32BIT_REG(rm);
            BX_CPU_THIS_PTR rm_addr += ((Bit8s) displ8);
            break;
          case 2:
            if (BX_CPU_THIS_PTR segment_override)
              BX_CPU_THIS_PTR rm_seg_reg = BX_CPU_THIS_PTR segment_override;
            else
              BX_CPU_THIS_PTR rm_seg_reg = BX_CPU_THIS_PTR sreg_mod10_rm32[rm];
            /* reg, 32-bit displacement */
            displ32 = fetch_next_dword();
            BX_CPU_THIS_PTR rm_addr = BX_READ_32BIT_REG(rm);
            BX_CPU_THIS_PTR rm_addr += displ32;
            break;
          } /* switch (mod) */
        } /* if (rm != 4) */
      else { /* rm == 4, s-i-b byte follows */
        sib = fetch_next_byte();
        base  = sib & 0x07; sib >>= 3;
        index = sib & 0x07; sib >>= 3;
        ss    = sib;

        switch (mod) {
          case 0:
            if (BX_CPU_THIS_PTR segment_override)
              BX_CPU_THIS_PTR rm_seg_reg = BX_CPU_THIS_PTR segment_override;
            else
              BX_CPU_THIS_PTR rm_seg_reg = BX_CPU_THIS_PTR sreg_mod00_base32[base];
            if (base != 5) /* base != 101b, no displacement */
              base_reg_val = BX_READ_32BIT_REG(base);
            else {
              base_reg_val = fetch_next_dword();
              }
            index_reg_val = 0;
            if (index != 4) {
              index_reg_val = BX_READ_32BIT_REG(index);
              index_reg_val <<= ss;
              }
            BX_CPU_THIS_PTR rm_addr = base_reg_val + index_reg_val;
            break;
          case 1:
            if (BX_CPU_THIS_PTR segment_override)
              BX_CPU_THIS_PTR rm_seg_reg = BX_CPU_THIS_PTR segment_override;
            else
              BX_CPU_THIS_PTR rm_seg_reg = BX_CPU_THIS_PTR sreg_mod01_base32[base];
            displ8 = fetch_next_byte();
            base_reg_val = BX_READ_32BIT_REG(base);
            index_reg_val = 0;
            if (index != 4) {
              index_reg_val = BX_READ_32BIT_REG(index);
              index_reg_val <<= ss;
              }
            BX_CPU_THIS_PTR rm_addr = base_reg_val + index_reg_val + (Bit8s) displ8;
            break;
          case 2:
            if (BX_CPU_THIS_PTR segment_override)
              BX_CPU_THIS_PTR rm_seg_reg = BX_CPU_THIS_PTR segment_override;
            else
              BX_CPU_THIS_PTR rm_seg_reg = BX_CPU_THIS_PTR sreg_mod10_base32[base];
            displ32 = fetch_next_dword();
            base_reg_val = BX_READ_32BIT_REG(base);
            index_reg_val = 0;
            if (index != 4) {
              index_reg_val = BX_READ_32BIT_REG(index);
              index_reg_val <<= ss;
              }
            BX_CPU_THIS_PTR rm_addr = base_reg_val + index_reg_val + displ32;
            break;
          }
        } /* s-i-b byte follows */
      } /* if (mod != 3) */
    }

  else
#endif   /* #if BX_CPU > 2 */
    {
    Bit8u  displ8;
    Bit16u displ16;
    Bit8u  modrm;

#if BX_WEIRDISMS
    BX_CPU_THIS_PTR rm_seg_reg = NULL;
#endif

    /* 16 bit addressing modes. */
    modrm = fetch_next_byte();
    BX_CPU_THIS_PTR modrm_ttt = (modrm >> 3) & 0x07;

    switch (modrm) {
      case 0x0:
        BX_CPU_THIS_PTR reg_index = 0x0;
        BX_CPU_THIS_PTR rm_type = BX_MEMORY_REF;
        BX_CPU_THIS_PTR rm_addr = (Bit16u) (BX + SI);
        if (BX_CPU_THIS_PTR segment_override)
          BX_CPU_THIS_PTR rm_seg_reg = BX_CPU_THIS_PTR segment_override;
        else
          BX_CPU_THIS_PTR rm_seg_reg = & BX_CPU_THIS_PTR ds;
        break;
      case 0x1:
        BX_CPU_THIS_PTR reg_index = 0x0;
        BX_CPU_THIS_PTR rm_type = BX_MEMORY_REF;
        BX_CPU_THIS_PTR rm_addr = (Bit16u) (BX + DI);
        if (BX_CPU_THIS_PTR segment_override)
          BX_CPU_THIS_PTR rm_seg_reg = BX_CPU_THIS_PTR segment_override;
        else
          BX_CPU_THIS_PTR rm_seg_reg = & BX_CPU_THIS_PTR ds;
        break;
      case 0x2:
        BX_CPU_THIS_PTR reg_index = 0x0;
        BX_CPU_THIS_PTR rm_type = BX_MEMORY_REF;
        BX_CPU_THIS_PTR rm_addr = (Bit16u) (BP + SI);
        if (BX_CPU_THIS_PTR segment_override)
          BX_CPU_THIS_PTR rm_seg_reg = BX_CPU_THIS_PTR segment_override;
        else
          BX_CPU_THIS_PTR rm_seg_reg = & BX_CPU_THIS_PTR ss;
        break;
      case 0x3:
        BX_CPU_THIS_PTR reg_index = 0x0;
        BX_CPU_THIS_PTR rm_type = BX_MEMORY_REF;
        BX_CPU_THIS_PTR rm_addr = (Bit16u) (BP + DI);
        if (BX_CPU_THIS_PTR segment_override)
          BX_CPU_THIS_PTR rm_seg_reg = BX_CPU_THIS_PTR segment_override;
        else
          BX_CPU_THIS_PTR rm_seg_reg = & BX_CPU_THIS_PTR ss;
        break;
      case 0x4:
        BX_CPU_THIS_PTR reg_index = 0x0;
        BX_CPU_THIS_PTR rm_type = BX_MEMORY_REF;
        BX_CPU_THIS_PTR rm_addr = (Bit16u) (SI);
        if (BX_CPU_THIS_PTR segment_override)
          BX_CPU_THIS_PTR rm_seg_reg = BX_CPU_THIS_PTR segment_override;
        else
          BX_CPU_THIS_PTR rm_seg_reg = & BX_CPU_THIS_PTR ds;
        break;
      case 0x5:
        BX_CPU_THIS_PTR reg_index = 0x0;
        BX_CPU_THIS_PTR rm_type = BX_MEMORY_REF;
        BX_CPU_THIS_PTR rm_addr = (Bit16u) (DI);
        if (BX_CPU_THIS_PTR segment_override)
          BX_CPU_THIS_PTR rm_seg_reg = BX_CPU_THIS_PTR segment_override;
        else
          BX_CPU_THIS_PTR rm_seg_reg = & BX_CPU_THIS_PTR ds;
        break;
      case 0x6:
        BX_CPU_THIS_PTR reg_index = 0x0;
        BX_CPU_THIS_PTR rm_type = BX_MEMORY_REF;
        BX_CPU_THIS_PTR rm_addr = (Bit16u) fetch_next_word();
        if (BX_CPU_THIS_PTR segment_override)
          BX_CPU_THIS_PTR rm_seg_reg = BX_CPU_THIS_PTR segment_override;
        else
          BX_CPU_THIS_PTR rm_seg_reg = & BX_CPU_THIS_PTR ds;
        break;
      case 0x7:
        BX_CPU_THIS_PTR reg_index = 0x0;
        BX_CPU_THIS_PTR rm_type = BX_MEMORY_REF;
        BX_CPU_THIS_PTR rm_addr = (Bit16u) (BX);
        if (BX_CPU_THIS_PTR segment_override)
          BX_CPU_THIS_PTR rm_seg_reg = BX_CPU_THIS_PTR segment_override;
        else
          BX_CPU_THIS_PTR rm_seg_reg = & BX_CPU_THIS_PTR ds;
        break;
      case 0x8:
        BX_CPU_THIS_PTR reg_index = 0x1;
        BX_CPU_THIS_PTR rm_type = BX_MEMORY_REF;
        BX_CPU_THIS_PTR rm_addr = (Bit16u) (BX + SI);
        if (BX_CPU_THIS_PTR segment_override)
          BX_CPU_THIS_PTR rm_seg_reg = BX_CPU_THIS_PTR segment_override;
        else
          BX_CPU_THIS_PTR rm_seg_reg = & BX_CPU_THIS_PTR ds;
        break;
      case 0x9:
        BX_CPU_THIS_PTR reg_index = 0x1;
        BX_CPU_THIS_PTR rm_type = BX_MEMORY_REF;
        BX_CPU_THIS_PTR rm_addr = (Bit16u) (BX + DI);
        if (BX_CPU_THIS_PTR segment_override)
          BX_CPU_THIS_PTR rm_seg_reg = BX_CPU_THIS_PTR segment_override;
        else
          BX_CPU_THIS_PTR rm_seg_reg = & BX_CPU_THIS_PTR ds;
        break;
      case 0xa:
        BX_CPU_THIS_PTR reg_index = 0x1;
        BX_CPU_THIS_PTR rm_type = BX_MEMORY_REF;
        BX_CPU_THIS_PTR rm_addr = (Bit16u) (BP + SI);
        if (BX_CPU_THIS_PTR segment_override)
          BX_CPU_THIS_PTR rm_seg_reg = BX_CPU_THIS_PTR segment_override;
        else
          BX_CPU_THIS_PTR rm_seg_reg = & BX_CPU_THIS_PTR ss;
        break;
      case 0xb:
        BX_CPU_THIS_PTR reg_index = 0x1;
        BX_CPU_THIS_PTR rm_type = BX_MEMORY_REF;
        BX_CPU_THIS_PTR rm_addr = (Bit16u) (BP + DI);
        if (BX_CPU_THIS_PTR segment_override)
          BX_CPU_THIS_PTR rm_seg_reg = BX_CPU_THIS_PTR segment_override;
        else
          BX_CPU_THIS_PTR rm_seg_reg = & BX_CPU_THIS_PTR ss;
        break;
      case 0xc:
        BX_CPU_THIS_PTR reg_index = 0x1;
        BX_CPU_THIS_PTR rm_type = BX_MEMORY_REF;
        BX_CPU_THIS_PTR rm_addr = (Bit16u) (SI);
        if (BX_CPU_THIS_PTR segment_override)
          BX_CPU_THIS_PTR rm_seg_reg = BX_CPU_THIS_PTR segment_override;
        else
          BX_CPU_THIS_PTR rm_seg_reg = & BX_CPU_THIS_PTR ds;
        break;
      case 0xd:
        BX_CPU_THIS_PTR reg_index = 0x1;
        BX_CPU_THIS_PTR rm_type = BX_MEMORY_REF;
        BX_CPU_THIS_PTR rm_addr = (Bit16u) (DI);
        if (BX_CPU_THIS_PTR segment_override)
          BX_CPU_THIS_PTR rm_seg_reg = BX_CPU_THIS_PTR segment_override;
        else
          BX_CPU_THIS_PTR rm_seg_reg = & BX_CPU_THIS_PTR ds;
        break;
      case 0xe:
        BX_CPU_THIS_PTR reg_index = 0x1;
        BX_CPU_THIS_PTR rm_type = BX_MEMORY_REF;
        BX_CPU_THIS_PTR rm_addr = (Bit16u) fetch_next_word();
        if (BX_CPU_THIS_PTR segment_override)
          BX_CPU_THIS_PTR rm_seg_reg = BX_CPU_THIS_PTR segment_override;
        else
          BX_CPU_THIS_PTR rm_seg_reg = & BX_CPU_THIS_PTR ds;
        break;
      case 0xf:
        BX_CPU_THIS_PTR reg_index = 0x1;
        BX_CPU_THIS_PTR rm_type = BX_MEMORY_REF;
        BX_CPU_THIS_PTR rm_addr = (Bit16u) (BX);
        if (BX_CPU_THIS_PTR segment_override)
          BX_CPU_THIS_PTR rm_seg_reg = BX_CPU_THIS_PTR segment_override;
        else
          BX_CPU_THIS_PTR rm_seg_reg = & BX_CPU_THIS_PTR ds;
        break;
      case 0x10:
        BX_CPU_THIS_PTR reg_index = 0x2;
        BX_CPU_THIS_PTR rm_type = BX_MEMORY_REF;
        BX_CPU_THIS_PTR rm_addr = (Bit16u) (BX + SI);
        if (BX_CPU_THIS_PTR segment_override)
          BX_CPU_THIS_PTR rm_seg_reg = BX_CPU_THIS_PTR segment_override;
        else
          BX_CPU_THIS_PTR rm_seg_reg = & BX_CPU_THIS_PTR ds;
        break;
      case 0x11:
        BX_CPU_THIS_PTR reg_index = 0x2;
        BX_CPU_THIS_PTR rm_type = BX_MEMORY_REF;
        BX_CPU_THIS_PTR rm_addr = (Bit16u) (BX + DI);
        if (BX_CPU_THIS_PTR segment_override)
          BX_CPU_THIS_PTR rm_seg_reg = BX_CPU_THIS_PTR segment_override;
        else
          BX_CPU_THIS_PTR rm_seg_reg = & BX_CPU_THIS_PTR ds;
        break;
      case 0x12:
        BX_CPU_THIS_PTR reg_index = 0x2;
        BX_CPU_THIS_PTR rm_type = BX_MEMORY_REF;
        BX_CPU_THIS_PTR rm_addr = (Bit16u) (BP + SI);
        if (BX_CPU_THIS_PTR segment_override)
          BX_CPU_THIS_PTR rm_seg_reg = BX_CPU_THIS_PTR segment_override;
        else
          BX_CPU_THIS_PTR rm_seg_reg = & BX_CPU_THIS_PTR ss;
        break;
      case 0x13:
        BX_CPU_THIS_PTR reg_index = 0x2;
        BX_CPU_THIS_PTR rm_type = BX_MEMORY_REF;
        BX_CPU_THIS_PTR rm_addr = (Bit16u) (BP + DI);
        if (BX_CPU_THIS_PTR segment_override)
          BX_CPU_THIS_PTR rm_seg_reg = BX_CPU_THIS_PTR segment_override;
        else
          BX_CPU_THIS_PTR rm_seg_reg = & BX_CPU_THIS_PTR ss;
        break;
      case 0x14:
        BX_CPU_THIS_PTR reg_index = 0x2;
        BX_CPU_THIS_PTR rm_type = BX_MEMORY_REF;
        BX_CPU_THIS_PTR rm_addr = (Bit16u) (SI);
        if (BX_CPU_THIS_PTR segment_override)
          BX_CPU_THIS_PTR rm_seg_reg = BX_CPU_THIS_PTR segment_override;
        else
          BX_CPU_THIS_PTR rm_seg_reg = & BX_CPU_THIS_PTR ds;
        break;
      case 0x15:
        BX_CPU_THIS_PTR reg_index = 0x2;
        BX_CPU_THIS_PTR rm_type = BX_MEMORY_REF;
        BX_CPU_THIS_PTR rm_addr = (Bit16u) (DI);
        if (BX_CPU_THIS_PTR segment_override)
          BX_CPU_THIS_PTR rm_seg_reg = BX_CPU_THIS_PTR segment_override;
        else
          BX_CPU_THIS_PTR rm_seg_reg = & BX_CPU_THIS_PTR ds;
        break;
      case 0x16:
        BX_CPU_THIS_PTR reg_index = 0x2;
        BX_CPU_THIS_PTR rm_type = BX_MEMORY_REF;
        BX_CPU_THIS_PTR rm_addr = (Bit16u) fetch_next_word();
        if (BX_CPU_THIS_PTR segment_override)
          BX_CPU_THIS_PTR rm_seg_reg = BX_CPU_THIS_PTR segment_override;
        else
          BX_CPU_THIS_PTR rm_seg_reg = & BX_CPU_THIS_PTR ds;
        break;
      case 0x17:
        BX_CPU_THIS_PTR reg_index = 0x2;
        BX_CPU_THIS_PTR rm_type = BX_MEMORY_REF;
        BX_CPU_THIS_PTR rm_addr = (Bit16u) (BX);
        if (BX_CPU_THIS_PTR segment_override)
          BX_CPU_THIS_PTR rm_seg_reg = BX_CPU_THIS_PTR segment_override;
        else
          BX_CPU_THIS_PTR rm_seg_reg = & BX_CPU_THIS_PTR ds;
        break;
      case 0x18:
        BX_CPU_THIS_PTR reg_index = 0x3;
        BX_CPU_THIS_PTR rm_type = BX_MEMORY_REF;
        BX_CPU_THIS_PTR rm_addr = (Bit16u) (BX + SI);
        if (BX_CPU_THIS_PTR segment_override)
          BX_CPU_THIS_PTR rm_seg_reg = BX_CPU_THIS_PTR segment_override;
        else
          BX_CPU_THIS_PTR rm_seg_reg = & BX_CPU_THIS_PTR ds;
        break;
      case 0x19:
        BX_CPU_THIS_PTR reg_index = 0x3;
        BX_CPU_THIS_PTR rm_type = BX_MEMORY_REF;
        BX_CPU_THIS_PTR rm_addr = (Bit16u) (BX + DI);
        if (BX_CPU_THIS_PTR segment_override)
          BX_CPU_THIS_PTR rm_seg_reg = BX_CPU_THIS_PTR segment_override;
        else
          BX_CPU_THIS_PTR rm_seg_reg = & BX_CPU_THIS_PTR ds;
        break;
      case 0x1a:
        BX_CPU_THIS_PTR reg_index = 0x3;
        BX_CPU_THIS_PTR rm_type = BX_MEMORY_REF;
        BX_CPU_THIS_PTR rm_addr = (Bit16u) (BP + SI);
        if (BX_CPU_THIS_PTR segment_override)
          BX_CPU_THIS_PTR rm_seg_reg = BX_CPU_THIS_PTR segment_override;
        else
          BX_CPU_THIS_PTR rm_seg_reg = & BX_CPU_THIS_PTR ss;
        break;
      case 0x1b:
        BX_CPU_THIS_PTR reg_index = 0x3;
        BX_CPU_THIS_PTR rm_type = BX_MEMORY_REF;
        BX_CPU_THIS_PTR rm_addr = (Bit16u) (BP + DI);
        if (BX_CPU_THIS_PTR segment_override)
          BX_CPU_THIS_PTR rm_seg_reg = BX_CPU_THIS_PTR segment_override;
        else
          BX_CPU_THIS_PTR rm_seg_reg = & BX_CPU_THIS_PTR ss;
        break;
      case 0x1c:
        BX_CPU_THIS_PTR reg_index = 0x3;
        BX_CPU_THIS_PTR rm_type = BX_MEMORY_REF;
        BX_CPU_THIS_PTR rm_addr = (Bit16u) (SI);
        if (BX_CPU_THIS_PTR segment_override)
          BX_CPU_THIS_PTR rm_seg_reg = BX_CPU_THIS_PTR segment_override;
        else
          BX_CPU_THIS_PTR rm_seg_reg = & BX_CPU_THIS_PTR ds;
        break;
      case 0x1d:
        BX_CPU_THIS_PTR reg_index = 0x3;
        BX_CPU_THIS_PTR rm_type = BX_MEMORY_REF;
        BX_CPU_THIS_PTR rm_addr = (Bit16u) (DI);
        if (BX_CPU_THIS_PTR segment_override)
          BX_CPU_THIS_PTR rm_seg_reg = BX_CPU_THIS_PTR segment_override;
        else
          BX_CPU_THIS_PTR rm_seg_reg = & BX_CPU_THIS_PTR ds;
        break;
      case 0x1e:
        BX_CPU_THIS_PTR reg_index = 0x3;
        BX_CPU_THIS_PTR rm_type = BX_MEMORY_REF;
        BX_CPU_THIS_PTR rm_addr = (Bit16u) fetch_next_word();
        if (BX_CPU_THIS_PTR segment_override)
          BX_CPU_THIS_PTR rm_seg_reg = BX_CPU_THIS_PTR segment_override;
        else
          BX_CPU_THIS_PTR rm_seg_reg = & BX_CPU_THIS_PTR ds;
        break;
      case 0x1f:
        BX_CPU_THIS_PTR reg_index = 0x3;
        BX_CPU_THIS_PTR rm_type = BX_MEMORY_REF;
        BX_CPU_THIS_PTR rm_addr = (Bit16u) (BX);
        if (BX_CPU_THIS_PTR segment_override)
          BX_CPU_THIS_PTR rm_seg_reg = BX_CPU_THIS_PTR segment_override;
        else
          BX_CPU_THIS_PTR rm_seg_reg = & BX_CPU_THIS_PTR ds;
        break;
      case 0x20:
        BX_CPU_THIS_PTR reg_index = 0x4;
        BX_CPU_THIS_PTR rm_type = BX_MEMORY_REF;
        BX_CPU_THIS_PTR rm_addr = (Bit16u) (BX + SI);
        if (BX_CPU_THIS_PTR segment_override)
          BX_CPU_THIS_PTR rm_seg_reg = BX_CPU_THIS_PTR segment_override;
        else
          BX_CPU_THIS_PTR rm_seg_reg = & BX_CPU_THIS_PTR ds;
        break;
      case 0x21:
        BX_CPU_THIS_PTR reg_index = 0x4;
        BX_CPU_THIS_PTR rm_type = BX_MEMORY_REF;
        BX_CPU_THIS_PTR rm_addr = (Bit16u) (BX + DI);
        if (BX_CPU_THIS_PTR segment_override)
          BX_CPU_THIS_PTR rm_seg_reg = BX_CPU_THIS_PTR segment_override;
        else
          BX_CPU_THIS_PTR rm_seg_reg = & BX_CPU_THIS_PTR ds;
        break;
      case 0x22:
        BX_CPU_THIS_PTR reg_index = 0x4;
        BX_CPU_THIS_PTR rm_type = BX_MEMORY_REF;
        BX_CPU_THIS_PTR rm_addr = (Bit16u) (BP + SI);
        if (BX_CPU_THIS_PTR segment_override)
          BX_CPU_THIS_PTR rm_seg_reg = BX_CPU_THIS_PTR segment_override;
        else
          BX_CPU_THIS_PTR rm_seg_reg = & BX_CPU_THIS_PTR ss;
        break;
      case 0x23:
        BX_CPU_THIS_PTR reg_index = 0x4;
        BX_CPU_THIS_PTR rm_type = BX_MEMORY_REF;
        BX_CPU_THIS_PTR rm_addr = (Bit16u) (BP + DI);
        if (BX_CPU_THIS_PTR segment_override)
          BX_CPU_THIS_PTR rm_seg_reg = BX_CPU_THIS_PTR segment_override;
        else
          BX_CPU_THIS_PTR rm_seg_reg = & BX_CPU_THIS_PTR ss;
        break;
      case 0x24:
        BX_CPU_THIS_PTR reg_index = 0x4;
        BX_CPU_THIS_PTR rm_type = BX_MEMORY_REF;
        BX_CPU_THIS_PTR rm_addr = (Bit16u) (SI);
        if (BX_CPU_THIS_PTR segment_override)
          BX_CPU_THIS_PTR rm_seg_reg = BX_CPU_THIS_PTR segment_override;
        else
          BX_CPU_THIS_PTR rm_seg_reg = & BX_CPU_THIS_PTR ds;
        break;
      case 0x25:
        BX_CPU_THIS_PTR reg_index = 0x4;
        BX_CPU_THIS_PTR rm_type = BX_MEMORY_REF;
        BX_CPU_THIS_PTR rm_addr = (Bit16u) (DI);
        if (BX_CPU_THIS_PTR segment_override)
          BX_CPU_THIS_PTR rm_seg_reg = BX_CPU_THIS_PTR segment_override;
        else
          BX_CPU_THIS_PTR rm_seg_reg = & BX_CPU_THIS_PTR ds;
        break;
      case 0x26:
        BX_CPU_THIS_PTR reg_index = 0x4;
        BX_CPU_THIS_PTR rm_type = BX_MEMORY_REF;
        BX_CPU_THIS_PTR rm_addr = (Bit16u) fetch_next_word();
        if (BX_CPU_THIS_PTR segment_override)
          BX_CPU_THIS_PTR rm_seg_reg = BX_CPU_THIS_PTR segment_override;
        else
          BX_CPU_THIS_PTR rm_seg_reg = & BX_CPU_THIS_PTR ds;
        break;
      case 0x27:
        BX_CPU_THIS_PTR reg_index = 0x4;
        BX_CPU_THIS_PTR rm_type = BX_MEMORY_REF;
        BX_CPU_THIS_PTR rm_addr = (Bit16u) (BX);
        if (BX_CPU_THIS_PTR segment_override)
          BX_CPU_THIS_PTR rm_seg_reg = BX_CPU_THIS_PTR segment_override;
        else
          BX_CPU_THIS_PTR rm_seg_reg = & BX_CPU_THIS_PTR ds;
        break;
      case 0x28:
        BX_CPU_THIS_PTR reg_index = 0x5;
        BX_CPU_THIS_PTR rm_type = BX_MEMORY_REF;
        BX_CPU_THIS_PTR rm_addr = (Bit16u) (BX + SI);
        if (BX_CPU_THIS_PTR segment_override)
          BX_CPU_THIS_PTR rm_seg_reg = BX_CPU_THIS_PTR segment_override;
        else
          BX_CPU_THIS_PTR rm_seg_reg = & BX_CPU_THIS_PTR ds;
        break;
      case 0x29:
        BX_CPU_THIS_PTR reg_index = 0x5;
        BX_CPU_THIS_PTR rm_type = BX_MEMORY_REF;
        BX_CPU_THIS_PTR rm_addr = (Bit16u) (BX + DI);
        if (BX_CPU_THIS_PTR segment_override)
          BX_CPU_THIS_PTR rm_seg_reg = BX_CPU_THIS_PTR segment_override;
        else
          BX_CPU_THIS_PTR rm_seg_reg = & BX_CPU_THIS_PTR ds;
        break;
      case 0x2a:
        BX_CPU_THIS_PTR reg_index = 0x5;
        BX_CPU_THIS_PTR rm_type = BX_MEMORY_REF;
        BX_CPU_THIS_PTR rm_addr = (Bit16u) (BP + SI);
        if (BX_CPU_THIS_PTR segment_override)
          BX_CPU_THIS_PTR rm_seg_reg = BX_CPU_THIS_PTR segment_override;
        else
          BX_CPU_THIS_PTR rm_seg_reg = & BX_CPU_THIS_PTR ss;
        break;
      case 0x2b:
        BX_CPU_THIS_PTR reg_index = 0x5;
        BX_CPU_THIS_PTR rm_type = BX_MEMORY_REF;
        BX_CPU_THIS_PTR rm_addr = (Bit16u) (BP + DI);
        if (BX_CPU_THIS_PTR segment_override)
          BX_CPU_THIS_PTR rm_seg_reg = BX_CPU_THIS_PTR segment_override;
        else
          BX_CPU_THIS_PTR rm_seg_reg = & BX_CPU_THIS_PTR ss;
        break;
      case 0x2c:
        BX_CPU_THIS_PTR reg_index = 0x5;
        BX_CPU_THIS_PTR rm_type = BX_MEMORY_REF;
        BX_CPU_THIS_PTR rm_addr = (Bit16u) (SI);
        if (BX_CPU_THIS_PTR segment_override)
          BX_CPU_THIS_PTR rm_seg_reg = BX_CPU_THIS_PTR segment_override;
        else
          BX_CPU_THIS_PTR rm_seg_reg = & BX_CPU_THIS_PTR ds;
        break;
      case 0x2d:
        BX_CPU_THIS_PTR reg_index = 0x5;
        BX_CPU_THIS_PTR rm_type = BX_MEMORY_REF;
        BX_CPU_THIS_PTR rm_addr = (Bit16u) (DI);
        if (BX_CPU_THIS_PTR segment_override)
          BX_CPU_THIS_PTR rm_seg_reg = BX_CPU_THIS_PTR segment_override;
        else
          BX_CPU_THIS_PTR rm_seg_reg = & BX_CPU_THIS_PTR ds;
        break;
      case 0x2e:
        BX_CPU_THIS_PTR reg_index = 0x5;
        BX_CPU_THIS_PTR rm_type = BX_MEMORY_REF;
        BX_CPU_THIS_PTR rm_addr = (Bit16u) fetch_next_word();
        if (BX_CPU_THIS_PTR segment_override)
          BX_CPU_THIS_PTR rm_seg_reg = BX_CPU_THIS_PTR segment_override;
        else
          BX_CPU_THIS_PTR rm_seg_reg = & BX_CPU_THIS_PTR ds;
        break;
      case 0x2f:
        BX_CPU_THIS_PTR reg_index = 0x5;
        BX_CPU_THIS_PTR rm_type = BX_MEMORY_REF;
        BX_CPU_THIS_PTR rm_addr = (Bit16u) (BX);
        if (BX_CPU_THIS_PTR segment_override)
          BX_CPU_THIS_PTR rm_seg_reg = BX_CPU_THIS_PTR segment_override;
        else
          BX_CPU_THIS_PTR rm_seg_reg = & BX_CPU_THIS_PTR ds;
        break;
      case 0x30:
        BX_CPU_THIS_PTR reg_index = 0x6;
        BX_CPU_THIS_PTR rm_type = BX_MEMORY_REF;
        BX_CPU_THIS_PTR rm_addr = (Bit16u) (BX + SI);
        if (BX_CPU_THIS_PTR segment_override)
          BX_CPU_THIS_PTR rm_seg_reg = BX_CPU_THIS_PTR segment_override;
        else
          BX_CPU_THIS_PTR rm_seg_reg = & BX_CPU_THIS_PTR ds;
        break;
      case 0x31:
        BX_CPU_THIS_PTR reg_index = 0x6;
        BX_CPU_THIS_PTR rm_type = BX_MEMORY_REF;
        BX_CPU_THIS_PTR rm_addr = (Bit16u) (BX + DI);
        if (BX_CPU_THIS_PTR segment_override)
          BX_CPU_THIS_PTR rm_seg_reg = BX_CPU_THIS_PTR segment_override;
        else
          BX_CPU_THIS_PTR rm_seg_reg = & BX_CPU_THIS_PTR ds;
        break;
      case 0x32:
        BX_CPU_THIS_PTR reg_index = 0x6;
        BX_CPU_THIS_PTR rm_type = BX_MEMORY_REF;
        BX_CPU_THIS_PTR rm_addr = (Bit16u) (BP + SI);
        if (BX_CPU_THIS_PTR segment_override)
          BX_CPU_THIS_PTR rm_seg_reg = BX_CPU_THIS_PTR segment_override;
        else
          BX_CPU_THIS_PTR rm_seg_reg = & BX_CPU_THIS_PTR ss;
        break;
      case 0x33:
        BX_CPU_THIS_PTR reg_index = 0x6;
        BX_CPU_THIS_PTR rm_type = BX_MEMORY_REF;
        BX_CPU_THIS_PTR rm_addr = (Bit16u) (BP + DI);
        if (BX_CPU_THIS_PTR segment_override)
          BX_CPU_THIS_PTR rm_seg_reg = BX_CPU_THIS_PTR segment_override;
        else
          BX_CPU_THIS_PTR rm_seg_reg = & BX_CPU_THIS_PTR ss;
        break;
      case 0x34:
        BX_CPU_THIS_PTR reg_index = 0x6;
        BX_CPU_THIS_PTR rm_type = BX_MEMORY_REF;
        BX_CPU_THIS_PTR rm_addr = (Bit16u) (SI);
        if (BX_CPU_THIS_PTR segment_override)
          BX_CPU_THIS_PTR rm_seg_reg = BX_CPU_THIS_PTR segment_override;
        else
          BX_CPU_THIS_PTR rm_seg_reg = & BX_CPU_THIS_PTR ds;
        break;
      case 0x35:
        BX_CPU_THIS_PTR reg_index = 0x6;
        BX_CPU_THIS_PTR rm_type = BX_MEMORY_REF;
        BX_CPU_THIS_PTR rm_addr = (Bit16u) (DI);
        if (BX_CPU_THIS_PTR segment_override)
          BX_CPU_THIS_PTR rm_seg_reg = BX_CPU_THIS_PTR segment_override;
        else
          BX_CPU_THIS_PTR rm_seg_reg = & BX_CPU_THIS_PTR ds;
        break;
      case 0x36:
        BX_CPU_THIS_PTR reg_index = 0x6;
        BX_CPU_THIS_PTR rm_type = BX_MEMORY_REF;
        BX_CPU_THIS_PTR rm_addr = (Bit16u) fetch_next_word();
        if (BX_CPU_THIS_PTR segment_override)
          BX_CPU_THIS_PTR rm_seg_reg = BX_CPU_THIS_PTR segment_override;
        else
          BX_CPU_THIS_PTR rm_seg_reg = & BX_CPU_THIS_PTR ds;
        break;
      case 0x37:
        BX_CPU_THIS_PTR reg_index = 0x6;
        BX_CPU_THIS_PTR rm_type = BX_MEMORY_REF;
        BX_CPU_THIS_PTR rm_addr = (Bit16u) (BX);
        if (BX_CPU_THIS_PTR segment_override)
          BX_CPU_THIS_PTR rm_seg_reg = BX_CPU_THIS_PTR segment_override;
        else
          BX_CPU_THIS_PTR rm_seg_reg = & BX_CPU_THIS_PTR ds;
        break;
      case 0x38:
        BX_CPU_THIS_PTR reg_index = 0x7;
        BX_CPU_THIS_PTR rm_type = BX_MEMORY_REF;
        BX_CPU_THIS_PTR rm_addr = (Bit16u) (BX + SI);
        if (BX_CPU_THIS_PTR segment_override)
          BX_CPU_THIS_PTR rm_seg_reg = BX_CPU_THIS_PTR segment_override;
        else
          BX_CPU_THIS_PTR rm_seg_reg = & BX_CPU_THIS_PTR ds;
        break;
      case 0x39:
        BX_CPU_THIS_PTR reg_index = 0x7;
        BX_CPU_THIS_PTR rm_type = BX_MEMORY_REF;
        BX_CPU_THIS_PTR rm_addr = (Bit16u) (BX + DI);
        if (BX_CPU_THIS_PTR segment_override)
          BX_CPU_THIS_PTR rm_seg_reg = BX_CPU_THIS_PTR segment_override;
        else
          BX_CPU_THIS_PTR rm_seg_reg = & BX_CPU_THIS_PTR ds;
        break;
      case 0x3a:
        BX_CPU_THIS_PTR reg_index = 0x7;
        BX_CPU_THIS_PTR rm_type = BX_MEMORY_REF;
        BX_CPU_THIS_PTR rm_addr = (Bit16u) (BP + SI);
        if (BX_CPU_THIS_PTR segment_override)
          BX_CPU_THIS_PTR rm_seg_reg = BX_CPU_THIS_PTR segment_override;
        else
          BX_CPU_THIS_PTR rm_seg_reg = & BX_CPU_THIS_PTR ss;
        break;
      case 0x3b:
        BX_CPU_THIS_PTR reg_index = 0x7;
        BX_CPU_THIS_PTR rm_type = BX_MEMORY_REF;
        BX_CPU_THIS_PTR rm_addr = (Bit16u) (BP + DI);
        if (BX_CPU_THIS_PTR segment_override)
          BX_CPU_THIS_PTR rm_seg_reg = BX_CPU_THIS_PTR segment_override;
        else
          BX_CPU_THIS_PTR rm_seg_reg = & BX_CPU_THIS_PTR ss;
        break;
      case 0x3c:
        BX_CPU_THIS_PTR reg_index = 0x7;
        BX_CPU_THIS_PTR rm_type = BX_MEMORY_REF;
        BX_CPU_THIS_PTR rm_addr = (Bit16u) (SI);
        if (BX_CPU_THIS_PTR segment_override)
          BX_CPU_THIS_PTR rm_seg_reg = BX_CPU_THIS_PTR segment_override;
        else
          BX_CPU_THIS_PTR rm_seg_reg = & BX_CPU_THIS_PTR ds;
        break;
      case 0x3d:
        BX_CPU_THIS_PTR reg_index = 0x7;
        BX_CPU_THIS_PTR rm_type = BX_MEMORY_REF;
        BX_CPU_THIS_PTR rm_addr = (Bit16u) (DI);
        if (BX_CPU_THIS_PTR segment_override)
          BX_CPU_THIS_PTR rm_seg_reg = BX_CPU_THIS_PTR segment_override;
        else
          BX_CPU_THIS_PTR rm_seg_reg = & BX_CPU_THIS_PTR ds;
        break;
      case 0x3e:
        BX_CPU_THIS_PTR reg_index = 0x7;
        BX_CPU_THIS_PTR rm_type = BX_MEMORY_REF;
        BX_CPU_THIS_PTR rm_addr = (Bit16u) fetch_next_word();
        if (BX_CPU_THIS_PTR segment_override)
          BX_CPU_THIS_PTR rm_seg_reg = BX_CPU_THIS_PTR segment_override;
        else
          BX_CPU_THIS_PTR rm_seg_reg = & BX_CPU_THIS_PTR ds;
        break;
      case 0x3f:
        BX_CPU_THIS_PTR reg_index = 0x7;
        BX_CPU_THIS_PTR rm_type = BX_MEMORY_REF;
        BX_CPU_THIS_PTR rm_addr = (Bit16u) (BX);
        if (BX_CPU_THIS_PTR segment_override)
          BX_CPU_THIS_PTR rm_seg_reg = BX_CPU_THIS_PTR segment_override;
        else
          BX_CPU_THIS_PTR rm_seg_reg = & BX_CPU_THIS_PTR ds;
        break;
      case 0x40:
        BX_CPU_THIS_PTR reg_index = 0x0;
        BX_CPU_THIS_PTR rm_type = BX_MEMORY_REF;
        displ8 = fetch_next_byte();
        BX_CPU_THIS_PTR rm_addr = (Bit16u) (BX + SI + (Bit8s) displ8);
        if (BX_CPU_THIS_PTR segment_override)
          BX_CPU_THIS_PTR rm_seg_reg = BX_CPU_THIS_PTR segment_override;
        else
          BX_CPU_THIS_PTR rm_seg_reg = & BX_CPU_THIS_PTR ds;
        break;
      case 0x41:
        BX_CPU_THIS_PTR reg_index = 0x0;
        BX_CPU_THIS_PTR rm_type = BX_MEMORY_REF;
        displ8 = fetch_next_byte();
        BX_CPU_THIS_PTR rm_addr = (Bit16u) (BX + DI + (Bit8s) displ8);
        if (BX_CPU_THIS_PTR segment_override)
          BX_CPU_THIS_PTR rm_seg_reg = BX_CPU_THIS_PTR segment_override;
        else
          BX_CPU_THIS_PTR rm_seg_reg = & BX_CPU_THIS_PTR ds;
        break;
      case 0x42:
        BX_CPU_THIS_PTR reg_index = 0x0;
        BX_CPU_THIS_PTR rm_type = BX_MEMORY_REF;
        displ8 = fetch_next_byte();
        BX_CPU_THIS_PTR rm_addr = (Bit16u) (BP + SI + (Bit8s) displ8);
        if (BX_CPU_THIS_PTR segment_override)
          BX_CPU_THIS_PTR rm_seg_reg = BX_CPU_THIS_PTR segment_override;
        else
          BX_CPU_THIS_PTR rm_seg_reg = & BX_CPU_THIS_PTR ss;
        break;
      case 0x43:
        BX_CPU_THIS_PTR reg_index = 0x0;
        BX_CPU_THIS_PTR rm_type = BX_MEMORY_REF;
        displ8 = fetch_next_byte();
        BX_CPU_THIS_PTR rm_addr = (Bit16u) (BP + DI + (Bit8s) displ8);
        if (BX_CPU_THIS_PTR segment_override)
          BX_CPU_THIS_PTR rm_seg_reg = BX_CPU_THIS_PTR segment_override;
        else
          BX_CPU_THIS_PTR rm_seg_reg = & BX_CPU_THIS_PTR ss;
        break;
      case 0x44:
        BX_CPU_THIS_PTR reg_index = 0x0;
        BX_CPU_THIS_PTR rm_type = BX_MEMORY_REF;
        displ8 = fetch_next_byte();
        BX_CPU_THIS_PTR rm_addr = (Bit16u) (SI + (Bit8s) displ8);
        if (BX_CPU_THIS_PTR segment_override)
          BX_CPU_THIS_PTR rm_seg_reg = BX_CPU_THIS_PTR segment_override;
        else
          BX_CPU_THIS_PTR rm_seg_reg = & BX_CPU_THIS_PTR ds;
        break;
      case 0x45:
        BX_CPU_THIS_PTR reg_index = 0x0;
        BX_CPU_THIS_PTR rm_type = BX_MEMORY_REF;
        displ8 = fetch_next_byte();
        BX_CPU_THIS_PTR rm_addr = (Bit16u) (DI + (Bit8s) displ8);
        if (BX_CPU_THIS_PTR segment_override)
          BX_CPU_THIS_PTR rm_seg_reg = BX_CPU_THIS_PTR segment_override;
        else
          BX_CPU_THIS_PTR rm_seg_reg = & BX_CPU_THIS_PTR ds;
        break;
      case 0x46:
        BX_CPU_THIS_PTR reg_index = 0x0;
        BX_CPU_THIS_PTR rm_type = BX_MEMORY_REF;
        displ8 = fetch_next_byte();
        BX_CPU_THIS_PTR rm_addr = (Bit16u) (BP + (Bit8s) displ8);
        if (BX_CPU_THIS_PTR segment_override)
          BX_CPU_THIS_PTR rm_seg_reg = BX_CPU_THIS_PTR segment_override;
        else
          BX_CPU_THIS_PTR rm_seg_reg = & BX_CPU_THIS_PTR ss;
        break;
      case 0x47:
        BX_CPU_THIS_PTR reg_index = 0x0;
        BX_CPU_THIS_PTR rm_type = BX_MEMORY_REF;
        displ8 = fetch_next_byte();
        BX_CPU_THIS_PTR rm_addr = (Bit16u) (BX + (Bit8s) displ8);
        if (BX_CPU_THIS_PTR segment_override)
          BX_CPU_THIS_PTR rm_seg_reg = BX_CPU_THIS_PTR segment_override;
        else
          BX_CPU_THIS_PTR rm_seg_reg = & BX_CPU_THIS_PTR ds;
        break;
      case 0x48:
        BX_CPU_THIS_PTR reg_index = 0x1;
        BX_CPU_THIS_PTR rm_type = BX_MEMORY_REF;
        displ8 = fetch_next_byte();
        BX_CPU_THIS_PTR rm_addr = (Bit16u) (BX + SI + (Bit8s) displ8);
        if (BX_CPU_THIS_PTR segment_override)
          BX_CPU_THIS_PTR rm_seg_reg = BX_CPU_THIS_PTR segment_override;
        else
          BX_CPU_THIS_PTR rm_seg_reg = & BX_CPU_THIS_PTR ds;
        break;
      case 0x49:
        BX_CPU_THIS_PTR reg_index = 0x1;
        BX_CPU_THIS_PTR rm_type = BX_MEMORY_REF;
        displ8 = fetch_next_byte();
        BX_CPU_THIS_PTR rm_addr = (Bit16u) (BX + DI + (Bit8s) displ8);
        if (BX_CPU_THIS_PTR segment_override)
          BX_CPU_THIS_PTR rm_seg_reg = BX_CPU_THIS_PTR segment_override;
        else
          BX_CPU_THIS_PTR rm_seg_reg = & BX_CPU_THIS_PTR ds;
        break;
      case 0x4a:
        BX_CPU_THIS_PTR reg_index = 0x1;
        BX_CPU_THIS_PTR rm_type = BX_MEMORY_REF;
        displ8 = fetch_next_byte();
        BX_CPU_THIS_PTR rm_addr = (Bit16u) (BP + SI + (Bit8s) displ8);
        if (BX_CPU_THIS_PTR segment_override)
          BX_CPU_THIS_PTR rm_seg_reg = BX_CPU_THIS_PTR segment_override;
        else
          BX_CPU_THIS_PTR rm_seg_reg = & BX_CPU_THIS_PTR ss;
        break;
      case 0x4b:
        BX_CPU_THIS_PTR reg_index = 0x1;
        BX_CPU_THIS_PTR rm_type = BX_MEMORY_REF;
        displ8 = fetch_next_byte();
        BX_CPU_THIS_PTR rm_addr = (Bit16u) (BP + DI + (Bit8s) displ8);
        if (BX_CPU_THIS_PTR segment_override)
          BX_CPU_THIS_PTR rm_seg_reg = BX_CPU_THIS_PTR segment_override;
        else
          BX_CPU_THIS_PTR rm_seg_reg = & BX_CPU_THIS_PTR ss;
        break;
      case 0x4c:
        BX_CPU_THIS_PTR reg_index = 0x1;
        BX_CPU_THIS_PTR rm_type = BX_MEMORY_REF;
        displ8 = fetch_next_byte();
        BX_CPU_THIS_PTR rm_addr = (Bit16u) (SI + (Bit8s) displ8);
        if (BX_CPU_THIS_PTR segment_override)
          BX_CPU_THIS_PTR rm_seg_reg = BX_CPU_THIS_PTR segment_override;
        else
          BX_CPU_THIS_PTR rm_seg_reg = & BX_CPU_THIS_PTR ds;
        break;
      case 0x4d:
        BX_CPU_THIS_PTR reg_index = 0x1;
        BX_CPU_THIS_PTR rm_type = BX_MEMORY_REF;
        displ8 = fetch_next_byte();
        BX_CPU_THIS_PTR rm_addr = (Bit16u) (DI + (Bit8s) displ8);
        if (BX_CPU_THIS_PTR segment_override)
          BX_CPU_THIS_PTR rm_seg_reg = BX_CPU_THIS_PTR segment_override;
        else
          BX_CPU_THIS_PTR rm_seg_reg = & BX_CPU_THIS_PTR ds;
        break;
      case 0x4e:
        BX_CPU_THIS_PTR reg_index = 0x1;
        BX_CPU_THIS_PTR rm_type = BX_MEMORY_REF;
        displ8 = fetch_next_byte();
        BX_CPU_THIS_PTR rm_addr = (Bit16u) (BP + (Bit8s) displ8);
        if (BX_CPU_THIS_PTR segment_override)
          BX_CPU_THIS_PTR rm_seg_reg = BX_CPU_THIS_PTR segment_override;
        else
          BX_CPU_THIS_PTR rm_seg_reg = & BX_CPU_THIS_PTR ss;
        break;
      case 0x4f:
        BX_CPU_THIS_PTR reg_index = 0x1;
        BX_CPU_THIS_PTR rm_type = BX_MEMORY_REF;
        displ8 = fetch_next_byte();
        BX_CPU_THIS_PTR rm_addr = (Bit16u) (BX + (Bit8s) displ8);
        if (BX_CPU_THIS_PTR segment_override)
          BX_CPU_THIS_PTR rm_seg_reg = BX_CPU_THIS_PTR segment_override;
        else
          BX_CPU_THIS_PTR rm_seg_reg = & BX_CPU_THIS_PTR ds;
        break;
      case 0x50:
        BX_CPU_THIS_PTR reg_index = 0x2;
        BX_CPU_THIS_PTR rm_type = BX_MEMORY_REF;
        displ8 = fetch_next_byte();
        BX_CPU_THIS_PTR rm_addr = (Bit16u) (BX + SI + (Bit8s) displ8);
        if (BX_CPU_THIS_PTR segment_override)
          BX_CPU_THIS_PTR rm_seg_reg = BX_CPU_THIS_PTR segment_override;
        else
          BX_CPU_THIS_PTR rm_seg_reg = & BX_CPU_THIS_PTR ds;
        break;
      case 0x51:
        BX_CPU_THIS_PTR reg_index = 0x2;
        BX_CPU_THIS_PTR rm_type = BX_MEMORY_REF;
        displ8 = fetch_next_byte();
        BX_CPU_THIS_PTR rm_addr = (Bit16u) (BX + DI + (Bit8s) displ8);
        if (BX_CPU_THIS_PTR segment_override)
          BX_CPU_THIS_PTR rm_seg_reg = BX_CPU_THIS_PTR segment_override;
        else
          BX_CPU_THIS_PTR rm_seg_reg = & BX_CPU_THIS_PTR ds;
        break;
      case 0x52:
        BX_CPU_THIS_PTR reg_index = 0x2;
        BX_CPU_THIS_PTR rm_type = BX_MEMORY_REF;
        displ8 = fetch_next_byte();
        BX_CPU_THIS_PTR rm_addr = (Bit16u) (BP + SI + (Bit8s) displ8);
        if (BX_CPU_THIS_PTR segment_override)
          BX_CPU_THIS_PTR rm_seg_reg = BX_CPU_THIS_PTR segment_override;
        else
          BX_CPU_THIS_PTR rm_seg_reg = & BX_CPU_THIS_PTR ss;
        break;
      case 0x53:
        BX_CPU_THIS_PTR reg_index = 0x2;
        BX_CPU_THIS_PTR rm_type = BX_MEMORY_REF;
        displ8 = fetch_next_byte();
        BX_CPU_THIS_PTR rm_addr = (Bit16u) (BP + DI + (Bit8s) displ8);
        if (BX_CPU_THIS_PTR segment_override)
          BX_CPU_THIS_PTR rm_seg_reg = BX_CPU_THIS_PTR segment_override;
        else
          BX_CPU_THIS_PTR rm_seg_reg = & BX_CPU_THIS_PTR ss;
        break;
      case 0x54:
        BX_CPU_THIS_PTR reg_index = 0x2;
        BX_CPU_THIS_PTR rm_type = BX_MEMORY_REF;
        displ8 = fetch_next_byte();
        BX_CPU_THIS_PTR rm_addr = (Bit16u) (SI + (Bit8s) displ8);
        if (BX_CPU_THIS_PTR segment_override)
          BX_CPU_THIS_PTR rm_seg_reg = BX_CPU_THIS_PTR segment_override;
        else
          BX_CPU_THIS_PTR rm_seg_reg = & BX_CPU_THIS_PTR ds;
        break;
      case 0x55:
        BX_CPU_THIS_PTR reg_index = 0x2;
        BX_CPU_THIS_PTR rm_type = BX_MEMORY_REF;
        displ8 = fetch_next_byte();
        BX_CPU_THIS_PTR rm_addr = (Bit16u) (DI + (Bit8s) displ8);
        if (BX_CPU_THIS_PTR segment_override)
          BX_CPU_THIS_PTR rm_seg_reg = BX_CPU_THIS_PTR segment_override;
        else
          BX_CPU_THIS_PTR rm_seg_reg = & BX_CPU_THIS_PTR ds;
        break;
      case 0x56:
        BX_CPU_THIS_PTR reg_index = 0x2;
        BX_CPU_THIS_PTR rm_type = BX_MEMORY_REF;
        displ8 = fetch_next_byte();
        BX_CPU_THIS_PTR rm_addr = (Bit16u) (BP + (Bit8s) displ8);
        if (BX_CPU_THIS_PTR segment_override)
          BX_CPU_THIS_PTR rm_seg_reg = BX_CPU_THIS_PTR segment_override;
        else
          BX_CPU_THIS_PTR rm_seg_reg = & BX_CPU_THIS_PTR ss;
        break;
      case 0x57:
        BX_CPU_THIS_PTR reg_index = 0x2;
        BX_CPU_THIS_PTR rm_type = BX_MEMORY_REF;
        displ8 = fetch_next_byte();
        BX_CPU_THIS_PTR rm_addr = (Bit16u) (BX + (Bit8s) displ8);
        if (BX_CPU_THIS_PTR segment_override)
          BX_CPU_THIS_PTR rm_seg_reg = BX_CPU_THIS_PTR segment_override;
        else
          BX_CPU_THIS_PTR rm_seg_reg = & BX_CPU_THIS_PTR ds;
        break;
      case 0x58:
        BX_CPU_THIS_PTR reg_index = 0x3;
        BX_CPU_THIS_PTR rm_type = BX_MEMORY_REF;
        displ8 = fetch_next_byte();
        BX_CPU_THIS_PTR rm_addr = (Bit16u) (BX + SI + (Bit8s) displ8);
        if (BX_CPU_THIS_PTR segment_override)
          BX_CPU_THIS_PTR rm_seg_reg = BX_CPU_THIS_PTR segment_override;
        else
          BX_CPU_THIS_PTR rm_seg_reg = & BX_CPU_THIS_PTR ds;
        break;
      case 0x59:
        BX_CPU_THIS_PTR reg_index = 0x3;
        BX_CPU_THIS_PTR rm_type = BX_MEMORY_REF;
        displ8 = fetch_next_byte();
        BX_CPU_THIS_PTR rm_addr = (Bit16u) (BX + DI + (Bit8s) displ8);
        if (BX_CPU_THIS_PTR segment_override)
          BX_CPU_THIS_PTR rm_seg_reg = BX_CPU_THIS_PTR segment_override;
        else
          BX_CPU_THIS_PTR rm_seg_reg = & BX_CPU_THIS_PTR ds;
        break;
      case 0x5a:
        BX_CPU_THIS_PTR reg_index = 0x3;
        BX_CPU_THIS_PTR rm_type = BX_MEMORY_REF;
        displ8 = fetch_next_byte();
        BX_CPU_THIS_PTR rm_addr = (Bit16u) (BP + SI + (Bit8s) displ8);
        if (BX_CPU_THIS_PTR segment_override)
          BX_CPU_THIS_PTR rm_seg_reg = BX_CPU_THIS_PTR segment_override;
        else
          BX_CPU_THIS_PTR rm_seg_reg = & BX_CPU_THIS_PTR ss;
        break;
      case 0x5b:
        BX_CPU_THIS_PTR reg_index = 0x3;
        BX_CPU_THIS_PTR rm_type = BX_MEMORY_REF;
        displ8 = fetch_next_byte();
        BX_CPU_THIS_PTR rm_addr = (Bit16u) (BP + DI + (Bit8s) displ8);
        if (BX_CPU_THIS_PTR segment_override)
          BX_CPU_THIS_PTR rm_seg_reg = BX_CPU_THIS_PTR segment_override;
        else
          BX_CPU_THIS_PTR rm_seg_reg = & BX_CPU_THIS_PTR ss;
        break;
      case 0x5c:
        BX_CPU_THIS_PTR reg_index = 0x3;
        BX_CPU_THIS_PTR rm_type = BX_MEMORY_REF;
        displ8 = fetch_next_byte();
        BX_CPU_THIS_PTR rm_addr = (Bit16u) (SI + (Bit8s) displ8);
        if (BX_CPU_THIS_PTR segment_override)
          BX_CPU_THIS_PTR rm_seg_reg = BX_CPU_THIS_PTR segment_override;
        else
          BX_CPU_THIS_PTR rm_seg_reg = & BX_CPU_THIS_PTR ds;
        break;
      case 0x5d:
        BX_CPU_THIS_PTR reg_index = 0x3;
        BX_CPU_THIS_PTR rm_type = BX_MEMORY_REF;
        displ8 = fetch_next_byte();
        BX_CPU_THIS_PTR rm_addr = (Bit16u) (DI + (Bit8s) displ8);
        if (BX_CPU_THIS_PTR segment_override)
          BX_CPU_THIS_PTR rm_seg_reg = BX_CPU_THIS_PTR segment_override;
        else
          BX_CPU_THIS_PTR rm_seg_reg = & BX_CPU_THIS_PTR ds;
        break;
      case 0x5e:
        BX_CPU_THIS_PTR reg_index = 0x3;
        BX_CPU_THIS_PTR rm_type = BX_MEMORY_REF;
        displ8 = fetch_next_byte();
        BX_CPU_THIS_PTR rm_addr = (Bit16u) (BP + (Bit8s) displ8);
        if (BX_CPU_THIS_PTR segment_override)
          BX_CPU_THIS_PTR rm_seg_reg = BX_CPU_THIS_PTR segment_override;
        else
          BX_CPU_THIS_PTR rm_seg_reg = & BX_CPU_THIS_PTR ss;
        break;
      case 0x5f:
        BX_CPU_THIS_PTR reg_index = 0x3;
        BX_CPU_THIS_PTR rm_type = BX_MEMORY_REF;
        displ8 = fetch_next_byte();
        BX_CPU_THIS_PTR rm_addr = (Bit16u) (BX + (Bit8s) displ8);
        if (BX_CPU_THIS_PTR segment_override)
          BX_CPU_THIS_PTR rm_seg_reg = BX_CPU_THIS_PTR segment_override;
        else
          BX_CPU_THIS_PTR rm_seg_reg = & BX_CPU_THIS_PTR ds;
        break;
      case 0x60:
        BX_CPU_THIS_PTR reg_index = 0x4;
        BX_CPU_THIS_PTR rm_type = BX_MEMORY_REF;
        displ8 = fetch_next_byte();
        BX_CPU_THIS_PTR rm_addr = (Bit16u) (BX + SI + (Bit8s) displ8);
        if (BX_CPU_THIS_PTR segment_override)
          BX_CPU_THIS_PTR rm_seg_reg = BX_CPU_THIS_PTR segment_override;
        else
          BX_CPU_THIS_PTR rm_seg_reg = & BX_CPU_THIS_PTR ds;
        break;
      case 0x61:
        BX_CPU_THIS_PTR reg_index = 0x4;
        BX_CPU_THIS_PTR rm_type = BX_MEMORY_REF;
        displ8 = fetch_next_byte();
        BX_CPU_THIS_PTR rm_addr = (Bit16u) (BX + DI + (Bit8s) displ8);
        if (BX_CPU_THIS_PTR segment_override)
          BX_CPU_THIS_PTR rm_seg_reg = BX_CPU_THIS_PTR segment_override;
        else
          BX_CPU_THIS_PTR rm_seg_reg = & BX_CPU_THIS_PTR ds;
        break;
      case 0x62:
        BX_CPU_THIS_PTR reg_index = 0x4;
        BX_CPU_THIS_PTR rm_type = BX_MEMORY_REF;
        displ8 = fetch_next_byte();
        BX_CPU_THIS_PTR rm_addr = (Bit16u) (BP + SI + (Bit8s) displ8);
        if (BX_CPU_THIS_PTR segment_override)
          BX_CPU_THIS_PTR rm_seg_reg = BX_CPU_THIS_PTR segment_override;
        else
          BX_CPU_THIS_PTR rm_seg_reg = & BX_CPU_THIS_PTR ss;
        break;
      case 0x63:
        BX_CPU_THIS_PTR reg_index = 0x4;
        BX_CPU_THIS_PTR rm_type = BX_MEMORY_REF;
        displ8 = fetch_next_byte();
        BX_CPU_THIS_PTR rm_addr = (Bit16u) (BP + DI + (Bit8s) displ8);
        if (BX_CPU_THIS_PTR segment_override)
          BX_CPU_THIS_PTR rm_seg_reg = BX_CPU_THIS_PTR segment_override;
        else
          BX_CPU_THIS_PTR rm_seg_reg = & BX_CPU_THIS_PTR ss;
        break;
      case 0x64:
        BX_CPU_THIS_PTR reg_index = 0x4;
        BX_CPU_THIS_PTR rm_type = BX_MEMORY_REF;
        displ8 = fetch_next_byte();
        BX_CPU_THIS_PTR rm_addr = (Bit16u) (SI + (Bit8s) displ8);
        if (BX_CPU_THIS_PTR segment_override)
          BX_CPU_THIS_PTR rm_seg_reg = BX_CPU_THIS_PTR segment_override;
        else
          BX_CPU_THIS_PTR rm_seg_reg = & BX_CPU_THIS_PTR ds;
        break;
      case 0x65:
        BX_CPU_THIS_PTR reg_index = 0x4;
        BX_CPU_THIS_PTR rm_type = BX_MEMORY_REF;
        displ8 = fetch_next_byte();
        BX_CPU_THIS_PTR rm_addr = (Bit16u) (DI + (Bit8s) displ8);
        if (BX_CPU_THIS_PTR segment_override)
          BX_CPU_THIS_PTR rm_seg_reg = BX_CPU_THIS_PTR segment_override;
        else
          BX_CPU_THIS_PTR rm_seg_reg = & BX_CPU_THIS_PTR ds;
        break;
      case 0x66:
        BX_CPU_THIS_PTR reg_index = 0x4;
        BX_CPU_THIS_PTR rm_type = BX_MEMORY_REF;
        displ8 = fetch_next_byte();
        BX_CPU_THIS_PTR rm_addr = (Bit16u) (BP + (Bit8s) displ8);
        if (BX_CPU_THIS_PTR segment_override)
          BX_CPU_THIS_PTR rm_seg_reg = BX_CPU_THIS_PTR segment_override;
        else
          BX_CPU_THIS_PTR rm_seg_reg = & BX_CPU_THIS_PTR ss;
        break;
      case 0x67:
        BX_CPU_THIS_PTR reg_index = 0x4;
        BX_CPU_THIS_PTR rm_type = BX_MEMORY_REF;
        displ8 = fetch_next_byte();
        BX_CPU_THIS_PTR rm_addr = (Bit16u) (BX + (Bit8s) displ8);
        if (BX_CPU_THIS_PTR segment_override)
          BX_CPU_THIS_PTR rm_seg_reg = BX_CPU_THIS_PTR segment_override;
        else
          BX_CPU_THIS_PTR rm_seg_reg = & BX_CPU_THIS_PTR ds;
        break;
      case 0x68:
        BX_CPU_THIS_PTR reg_index = 0x5;
        BX_CPU_THIS_PTR rm_type = BX_MEMORY_REF;
        displ8 = fetch_next_byte();
        BX_CPU_THIS_PTR rm_addr = (Bit16u) (BX + SI + (Bit8s) displ8);
        if (BX_CPU_THIS_PTR segment_override)
          BX_CPU_THIS_PTR rm_seg_reg = BX_CPU_THIS_PTR segment_override;
        else
          BX_CPU_THIS_PTR rm_seg_reg = & BX_CPU_THIS_PTR ds;
        break;
      case 0x69:
        BX_CPU_THIS_PTR reg_index = 0x5;
        BX_CPU_THIS_PTR rm_type = BX_MEMORY_REF;
        displ8 = fetch_next_byte();
        BX_CPU_THIS_PTR rm_addr = (Bit16u) (BX + DI + (Bit8s) displ8);
        if (BX_CPU_THIS_PTR segment_override)
          BX_CPU_THIS_PTR rm_seg_reg = BX_CPU_THIS_PTR segment_override;
        else
          BX_CPU_THIS_PTR rm_seg_reg = & BX_CPU_THIS_PTR ds;
        break;
      case 0x6a:
        BX_CPU_THIS_PTR reg_index = 0x5;
        BX_CPU_THIS_PTR rm_type = BX_MEMORY_REF;
        displ8 = fetch_next_byte();
        BX_CPU_THIS_PTR rm_addr = (Bit16u) (BP + SI + (Bit8s) displ8);
        if (BX_CPU_THIS_PTR segment_override)
          BX_CPU_THIS_PTR rm_seg_reg = BX_CPU_THIS_PTR segment_override;
        else
          BX_CPU_THIS_PTR rm_seg_reg = & BX_CPU_THIS_PTR ss;
        break;
      case 0x6b:
        BX_CPU_THIS_PTR reg_index = 0x5;
        BX_CPU_THIS_PTR rm_type = BX_MEMORY_REF;
        displ8 = fetch_next_byte();
        BX_CPU_THIS_PTR rm_addr = (Bit16u) (BP + DI + (Bit8s) displ8);
        if (BX_CPU_THIS_PTR segment_override)
          BX_CPU_THIS_PTR rm_seg_reg = BX_CPU_THIS_PTR segment_override;
        else
          BX_CPU_THIS_PTR rm_seg_reg = & BX_CPU_THIS_PTR ss;
        break;
      case 0x6c:
        BX_CPU_THIS_PTR reg_index = 0x5;
        BX_CPU_THIS_PTR rm_type = BX_MEMORY_REF;
        displ8 = fetch_next_byte();
        BX_CPU_THIS_PTR rm_addr = (Bit16u) (SI + (Bit8s) displ8);
        if (BX_CPU_THIS_PTR segment_override)
          BX_CPU_THIS_PTR rm_seg_reg = BX_CPU_THIS_PTR segment_override;
        else
          BX_CPU_THIS_PTR rm_seg_reg = & BX_CPU_THIS_PTR ds;
        break;
      case 0x6d:
        BX_CPU_THIS_PTR reg_index = 0x5;
        BX_CPU_THIS_PTR rm_type = BX_MEMORY_REF;
        displ8 = fetch_next_byte();
        BX_CPU_THIS_PTR rm_addr = (Bit16u) (DI + (Bit8s) displ8);
        if (BX_CPU_THIS_PTR segment_override)
          BX_CPU_THIS_PTR rm_seg_reg = BX_CPU_THIS_PTR segment_override;
        else
          BX_CPU_THIS_PTR rm_seg_reg = & BX_CPU_THIS_PTR ds;
        break;
      case 0x6e:
        BX_CPU_THIS_PTR reg_index = 0x5;
        BX_CPU_THIS_PTR rm_type = BX_MEMORY_REF;
        displ8 = fetch_next_byte();
        BX_CPU_THIS_PTR rm_addr = (Bit16u) (BP + (Bit8s) displ8);
        if (BX_CPU_THIS_PTR segment_override)
          BX_CPU_THIS_PTR rm_seg_reg = BX_CPU_THIS_PTR segment_override;
        else
          BX_CPU_THIS_PTR rm_seg_reg = & BX_CPU_THIS_PTR ss;
        break;
      case 0x6f:
        BX_CPU_THIS_PTR reg_index = 0x5;
        BX_CPU_THIS_PTR rm_type = BX_MEMORY_REF;
        displ8 = fetch_next_byte();
        BX_CPU_THIS_PTR rm_addr = (Bit16u) (BX + (Bit8s) displ8);
        if (BX_CPU_THIS_PTR segment_override)
          BX_CPU_THIS_PTR rm_seg_reg = BX_CPU_THIS_PTR segment_override;
        else
          BX_CPU_THIS_PTR rm_seg_reg = & BX_CPU_THIS_PTR ds;
        break;
      case 0x70:
        BX_CPU_THIS_PTR reg_index = 0x6;
        BX_CPU_THIS_PTR rm_type = BX_MEMORY_REF;
        displ8 = fetch_next_byte();
        BX_CPU_THIS_PTR rm_addr = (Bit16u) (BX + SI + (Bit8s) displ8);
        if (BX_CPU_THIS_PTR segment_override)
          BX_CPU_THIS_PTR rm_seg_reg = BX_CPU_THIS_PTR segment_override;
        else
          BX_CPU_THIS_PTR rm_seg_reg = & BX_CPU_THIS_PTR ds;
        break;
      case 0x71:
        BX_CPU_THIS_PTR reg_index = 0x6;
        BX_CPU_THIS_PTR rm_type = BX_MEMORY_REF;
        displ8 = fetch_next_byte();
        BX_CPU_THIS_PTR rm_addr = (Bit16u) (BX + DI + (Bit8s) displ8);
        if (BX_CPU_THIS_PTR segment_override)
          BX_CPU_THIS_PTR rm_seg_reg = BX_CPU_THIS_PTR segment_override;
        else
          BX_CPU_THIS_PTR rm_seg_reg = & BX_CPU_THIS_PTR ds;
        break;
      case 0x72:
        BX_CPU_THIS_PTR reg_index = 0x6;
        BX_CPU_THIS_PTR rm_type = BX_MEMORY_REF;
        displ8 = fetch_next_byte();
        BX_CPU_THIS_PTR rm_addr = (Bit16u) (BP + SI + (Bit8s) displ8);
        if (BX_CPU_THIS_PTR segment_override)
          BX_CPU_THIS_PTR rm_seg_reg = BX_CPU_THIS_PTR segment_override;
        else
          BX_CPU_THIS_PTR rm_seg_reg = & BX_CPU_THIS_PTR ss;
        break;
      case 0x73:
        BX_CPU_THIS_PTR reg_index = 0x6;
        BX_CPU_THIS_PTR rm_type = BX_MEMORY_REF;
        displ8 = fetch_next_byte();
        BX_CPU_THIS_PTR rm_addr = (Bit16u) (BP + DI + (Bit8s) displ8);
        if (BX_CPU_THIS_PTR segment_override)
          BX_CPU_THIS_PTR rm_seg_reg = BX_CPU_THIS_PTR segment_override;
        else
          BX_CPU_THIS_PTR rm_seg_reg = & BX_CPU_THIS_PTR ss;
        break;
      case 0x74:
        BX_CPU_THIS_PTR reg_index = 0x6;
        BX_CPU_THIS_PTR rm_type = BX_MEMORY_REF;
        displ8 = fetch_next_byte();
        BX_CPU_THIS_PTR rm_addr = (Bit16u) (SI + (Bit8s) displ8);
        if (BX_CPU_THIS_PTR segment_override)
          BX_CPU_THIS_PTR rm_seg_reg = BX_CPU_THIS_PTR segment_override;
        else
          BX_CPU_THIS_PTR rm_seg_reg = & BX_CPU_THIS_PTR ds;
        break;
      case 0x75:
        BX_CPU_THIS_PTR reg_index = 0x6;
        BX_CPU_THIS_PTR rm_type = BX_MEMORY_REF;
        displ8 = fetch_next_byte();
        BX_CPU_THIS_PTR rm_addr = (Bit16u) (DI + (Bit8s) displ8);
        if (BX_CPU_THIS_PTR segment_override)
          BX_CPU_THIS_PTR rm_seg_reg = BX_CPU_THIS_PTR segment_override;
        else
          BX_CPU_THIS_PTR rm_seg_reg = & BX_CPU_THIS_PTR ds;
        break;
      case 0x76:
        BX_CPU_THIS_PTR reg_index = 0x6;
        BX_CPU_THIS_PTR rm_type = BX_MEMORY_REF;
        displ8 = fetch_next_byte();
        BX_CPU_THIS_PTR rm_addr = (Bit16u) (BP + (Bit8s) displ8);
        if (BX_CPU_THIS_PTR segment_override)
          BX_CPU_THIS_PTR rm_seg_reg = BX_CPU_THIS_PTR segment_override;
        else
          BX_CPU_THIS_PTR rm_seg_reg = & BX_CPU_THIS_PTR ss;
        break;
      case 0x77:
        BX_CPU_THIS_PTR reg_index = 0x6;
        BX_CPU_THIS_PTR rm_type = BX_MEMORY_REF;
        displ8 = fetch_next_byte();
        BX_CPU_THIS_PTR rm_addr = (Bit16u) (BX + (Bit8s) displ8);
        if (BX_CPU_THIS_PTR segment_override)
          BX_CPU_THIS_PTR rm_seg_reg = BX_CPU_THIS_PTR segment_override;
        else
          BX_CPU_THIS_PTR rm_seg_reg = & BX_CPU_THIS_PTR ds;
        break;
      case 0x78:
        BX_CPU_THIS_PTR reg_index = 0x7;
        BX_CPU_THIS_PTR rm_type = BX_MEMORY_REF;
        displ8 = fetch_next_byte();
        BX_CPU_THIS_PTR rm_addr = (Bit16u) (BX + SI + (Bit8s) displ8);
        if (BX_CPU_THIS_PTR segment_override)
          BX_CPU_THIS_PTR rm_seg_reg = BX_CPU_THIS_PTR segment_override;
        else
          BX_CPU_THIS_PTR rm_seg_reg = & BX_CPU_THIS_PTR ds;
        break;
      case 0x79:
        BX_CPU_THIS_PTR reg_index = 0x7;
        BX_CPU_THIS_PTR rm_type = BX_MEMORY_REF;
        displ8 = fetch_next_byte();
        BX_CPU_THIS_PTR rm_addr = (Bit16u) (BX + DI + (Bit8s) displ8);
        if (BX_CPU_THIS_PTR segment_override)
          BX_CPU_THIS_PTR rm_seg_reg = BX_CPU_THIS_PTR segment_override;
        else
          BX_CPU_THIS_PTR rm_seg_reg = & BX_CPU_THIS_PTR ds;
        break;
      case 0x7a:
        BX_CPU_THIS_PTR reg_index = 0x7;
        BX_CPU_THIS_PTR rm_type = BX_MEMORY_REF;
        displ8 = fetch_next_byte();
        BX_CPU_THIS_PTR rm_addr = (Bit16u) (BP + SI + (Bit8s) displ8);
        if (BX_CPU_THIS_PTR segment_override)
          BX_CPU_THIS_PTR rm_seg_reg = BX_CPU_THIS_PTR segment_override;
        else
          BX_CPU_THIS_PTR rm_seg_reg = & BX_CPU_THIS_PTR ss;
        break;
      case 0x7b:
        BX_CPU_THIS_PTR reg_index = 0x7;
        BX_CPU_THIS_PTR rm_type = BX_MEMORY_REF;
        displ8 = fetch_next_byte();
        BX_CPU_THIS_PTR rm_addr = (Bit16u) (BP + DI + (Bit8s) displ8);
        if (BX_CPU_THIS_PTR segment_override)
          BX_CPU_THIS_PTR rm_seg_reg = BX_CPU_THIS_PTR segment_override;
        else
          BX_CPU_THIS_PTR rm_seg_reg = & BX_CPU_THIS_PTR ss;
        break;
      case 0x7c:
        BX_CPU_THIS_PTR reg_index = 0x7;
        BX_CPU_THIS_PTR rm_type = BX_MEMORY_REF;
        displ8 = fetch_next_byte();
        BX_CPU_THIS_PTR rm_addr = (Bit16u) (SI + (Bit8s) displ8);
        if (BX_CPU_THIS_PTR segment_override)
          BX_CPU_THIS_PTR rm_seg_reg = BX_CPU_THIS_PTR segment_override;
        else
          BX_CPU_THIS_PTR rm_seg_reg = & BX_CPU_THIS_PTR ds;
        break;
      case 0x7d:
        BX_CPU_THIS_PTR reg_index = 0x7;
        BX_CPU_THIS_PTR rm_type = BX_MEMORY_REF;
        displ8 = fetch_next_byte();
        BX_CPU_THIS_PTR rm_addr = (Bit16u) (DI + (Bit8s) displ8);
        if (BX_CPU_THIS_PTR segment_override)
          BX_CPU_THIS_PTR rm_seg_reg = BX_CPU_THIS_PTR segment_override;
        else
          BX_CPU_THIS_PTR rm_seg_reg = & BX_CPU_THIS_PTR ds;
        break;
      case 0x7e:
        BX_CPU_THIS_PTR reg_index = 0x7;
        BX_CPU_THIS_PTR rm_type = BX_MEMORY_REF;
        displ8 = fetch_next_byte();
        BX_CPU_THIS_PTR rm_addr = (Bit16u) (BP + (Bit8s) displ8);
        if (BX_CPU_THIS_PTR segment_override)
          BX_CPU_THIS_PTR rm_seg_reg = BX_CPU_THIS_PTR segment_override;
        else
          BX_CPU_THIS_PTR rm_seg_reg = & BX_CPU_THIS_PTR ss;
        break;
      case 0x7f:
        BX_CPU_THIS_PTR reg_index = 0x7;
        BX_CPU_THIS_PTR rm_type = BX_MEMORY_REF;
        displ8 = fetch_next_byte();
        BX_CPU_THIS_PTR rm_addr = (Bit16u) (BX + (Bit8s) displ8);
        if (BX_CPU_THIS_PTR segment_override)
          BX_CPU_THIS_PTR rm_seg_reg = BX_CPU_THIS_PTR segment_override;
        else
          BX_CPU_THIS_PTR rm_seg_reg = & BX_CPU_THIS_PTR ds;
        break;
      case 0x80:
        BX_CPU_THIS_PTR reg_index = 0x0;
        BX_CPU_THIS_PTR rm_type = BX_MEMORY_REF;
        displ16 = fetch_next_word();
        BX_CPU_THIS_PTR rm_addr = (Bit16u) (BX + SI + displ16);
        if (BX_CPU_THIS_PTR segment_override)
          BX_CPU_THIS_PTR rm_seg_reg = BX_CPU_THIS_PTR segment_override;
        else
          BX_CPU_THIS_PTR rm_seg_reg = & BX_CPU_THIS_PTR ds;
        break;
      case 0x81:
        BX_CPU_THIS_PTR reg_index = 0x0;
        BX_CPU_THIS_PTR rm_type = BX_MEMORY_REF;
        displ16 = fetch_next_word();
        BX_CPU_THIS_PTR rm_addr = (Bit16u) (BX + DI + displ16);
        if (BX_CPU_THIS_PTR segment_override)
          BX_CPU_THIS_PTR rm_seg_reg = BX_CPU_THIS_PTR segment_override;
        else
          BX_CPU_THIS_PTR rm_seg_reg = & BX_CPU_THIS_PTR ds;
        break;
      case 0x82:
        BX_CPU_THIS_PTR reg_index = 0x0;
        BX_CPU_THIS_PTR rm_type = BX_MEMORY_REF;
        displ16 = fetch_next_word();
        BX_CPU_THIS_PTR rm_addr = (Bit16u) (BP + SI + displ16);
        if (BX_CPU_THIS_PTR segment_override)
          BX_CPU_THIS_PTR rm_seg_reg = BX_CPU_THIS_PTR segment_override;
        else
          BX_CPU_THIS_PTR rm_seg_reg = & BX_CPU_THIS_PTR ss;
        break;
      case 0x83:
        BX_CPU_THIS_PTR reg_index = 0x0;
        BX_CPU_THIS_PTR rm_type = BX_MEMORY_REF;
        displ16 = fetch_next_word();
        BX_CPU_THIS_PTR rm_addr = (Bit16u) (BP + DI + displ16);
        if (BX_CPU_THIS_PTR segment_override)
          BX_CPU_THIS_PTR rm_seg_reg = BX_CPU_THIS_PTR segment_override;
        else
          BX_CPU_THIS_PTR rm_seg_reg = & BX_CPU_THIS_PTR ss;
        break;
      case 0x84:
        BX_CPU_THIS_PTR reg_index = 0x0;
        BX_CPU_THIS_PTR rm_type = BX_MEMORY_REF;
        displ16 = fetch_next_word();
        BX_CPU_THIS_PTR rm_addr = (Bit16u) (SI + displ16);
        if (BX_CPU_THIS_PTR segment_override)
          BX_CPU_THIS_PTR rm_seg_reg = BX_CPU_THIS_PTR segment_override;
        else
          BX_CPU_THIS_PTR rm_seg_reg = & BX_CPU_THIS_PTR ds;
        break;
      case 0x85:
        BX_CPU_THIS_PTR reg_index = 0x0;
        BX_CPU_THIS_PTR rm_type = BX_MEMORY_REF;
        displ16 = fetch_next_word();
        BX_CPU_THIS_PTR rm_addr = (Bit16u) (DI + displ16);
        if (BX_CPU_THIS_PTR segment_override)
          BX_CPU_THIS_PTR rm_seg_reg = BX_CPU_THIS_PTR segment_override;
        else
          BX_CPU_THIS_PTR rm_seg_reg = & BX_CPU_THIS_PTR ds;
        break;
      case 0x86:
        BX_CPU_THIS_PTR reg_index = 0x0;
        BX_CPU_THIS_PTR rm_type = BX_MEMORY_REF;
        displ16 = fetch_next_word();
        BX_CPU_THIS_PTR rm_addr = (Bit16u) (BP + displ16);
        if (BX_CPU_THIS_PTR segment_override)
          BX_CPU_THIS_PTR rm_seg_reg = BX_CPU_THIS_PTR segment_override;
        else
          BX_CPU_THIS_PTR rm_seg_reg = & BX_CPU_THIS_PTR ss;
        break;
      case 0x87:
        BX_CPU_THIS_PTR reg_index = 0x0;
        BX_CPU_THIS_PTR rm_type = BX_MEMORY_REF;
        displ16 = fetch_next_word();
        BX_CPU_THIS_PTR rm_addr = (Bit16u) (BX + displ16);
        if (BX_CPU_THIS_PTR segment_override)
          BX_CPU_THIS_PTR rm_seg_reg = BX_CPU_THIS_PTR segment_override;
        else
          BX_CPU_THIS_PTR rm_seg_reg = & BX_CPU_THIS_PTR ds;
        break;
      case 0x88:
        BX_CPU_THIS_PTR reg_index = 0x1;
        BX_CPU_THIS_PTR rm_type = BX_MEMORY_REF;
        displ16 = fetch_next_word();
        BX_CPU_THIS_PTR rm_addr = (Bit16u) (BX + SI + displ16);
        if (BX_CPU_THIS_PTR segment_override)
          BX_CPU_THIS_PTR rm_seg_reg = BX_CPU_THIS_PTR segment_override;
        else
          BX_CPU_THIS_PTR rm_seg_reg = & BX_CPU_THIS_PTR ds;
        break;
      case 0x89:
        BX_CPU_THIS_PTR reg_index = 0x1;
        BX_CPU_THIS_PTR rm_type = BX_MEMORY_REF;
        displ16 = fetch_next_word();
        BX_CPU_THIS_PTR rm_addr = (Bit16u) (BX + DI + displ16);
        if (BX_CPU_THIS_PTR segment_override)
          BX_CPU_THIS_PTR rm_seg_reg = BX_CPU_THIS_PTR segment_override;
        else
          BX_CPU_THIS_PTR rm_seg_reg = & BX_CPU_THIS_PTR ds;
        break;
      case 0x8a:
        BX_CPU_THIS_PTR reg_index = 0x1;
        BX_CPU_THIS_PTR rm_type = BX_MEMORY_REF;
        displ16 = fetch_next_word();
        BX_CPU_THIS_PTR rm_addr = (Bit16u) (BP + SI + displ16);
        if (BX_CPU_THIS_PTR segment_override)
          BX_CPU_THIS_PTR rm_seg_reg = BX_CPU_THIS_PTR segment_override;
        else
          BX_CPU_THIS_PTR rm_seg_reg = & BX_CPU_THIS_PTR ss;
        break;
      case 0x8b:
        BX_CPU_THIS_PTR reg_index = 0x1;
        BX_CPU_THIS_PTR rm_type = BX_MEMORY_REF;
        displ16 = fetch_next_word();
        BX_CPU_THIS_PTR rm_addr = (Bit16u) (BP + DI + displ16);
        if (BX_CPU_THIS_PTR segment_override)
          BX_CPU_THIS_PTR rm_seg_reg = BX_CPU_THIS_PTR segment_override;
        else
          BX_CPU_THIS_PTR rm_seg_reg = & BX_CPU_THIS_PTR ss;
        break;
      case 0x8c:
        BX_CPU_THIS_PTR reg_index = 0x1;
        BX_CPU_THIS_PTR rm_type = BX_MEMORY_REF;
        displ16 = fetch_next_word();
        BX_CPU_THIS_PTR rm_addr = (Bit16u) (SI + displ16);
        if (BX_CPU_THIS_PTR segment_override)
          BX_CPU_THIS_PTR rm_seg_reg = BX_CPU_THIS_PTR segment_override;
        else
          BX_CPU_THIS_PTR rm_seg_reg = & BX_CPU_THIS_PTR ds;
        break;
      case 0x8d:
        BX_CPU_THIS_PTR reg_index = 0x1;
        BX_CPU_THIS_PTR rm_type = BX_MEMORY_REF;
        displ16 = fetch_next_word();
        BX_CPU_THIS_PTR rm_addr = (Bit16u) (DI + displ16);
        if (BX_CPU_THIS_PTR segment_override)
          BX_CPU_THIS_PTR rm_seg_reg = BX_CPU_THIS_PTR segment_override;
        else
          BX_CPU_THIS_PTR rm_seg_reg = & BX_CPU_THIS_PTR ds;
        break;
      case 0x8e:
        BX_CPU_THIS_PTR reg_index = 0x1;
        BX_CPU_THIS_PTR rm_type = BX_MEMORY_REF;
        displ16 = fetch_next_word();
        BX_CPU_THIS_PTR rm_addr = (Bit16u) (BP + displ16);
        if (BX_CPU_THIS_PTR segment_override)
          BX_CPU_THIS_PTR rm_seg_reg = BX_CPU_THIS_PTR segment_override;
        else
          BX_CPU_THIS_PTR rm_seg_reg = & BX_CPU_THIS_PTR ss;
        break;
      case 0x8f:
        BX_CPU_THIS_PTR reg_index = 0x1;
        BX_CPU_THIS_PTR rm_type = BX_MEMORY_REF;
        displ16 = fetch_next_word();
        BX_CPU_THIS_PTR rm_addr = (Bit16u) (BX + displ16);
        if (BX_CPU_THIS_PTR segment_override)
          BX_CPU_THIS_PTR rm_seg_reg = BX_CPU_THIS_PTR segment_override;
        else
          BX_CPU_THIS_PTR rm_seg_reg = & BX_CPU_THIS_PTR ds;
        break;
      case 0x90:
        BX_CPU_THIS_PTR reg_index = 0x2;
        BX_CPU_THIS_PTR rm_type = BX_MEMORY_REF;
        displ16 = fetch_next_word();
        BX_CPU_THIS_PTR rm_addr = (Bit16u) (BX + SI + displ16);
        if (BX_CPU_THIS_PTR segment_override)
          BX_CPU_THIS_PTR rm_seg_reg = BX_CPU_THIS_PTR segment_override;
        else
          BX_CPU_THIS_PTR rm_seg_reg = & BX_CPU_THIS_PTR ds;
        break;
      case 0x91:
        BX_CPU_THIS_PTR reg_index = 0x2;
        BX_CPU_THIS_PTR rm_type = BX_MEMORY_REF;
        displ16 = fetch_next_word();
        BX_CPU_THIS_PTR rm_addr = (Bit16u) (BX + DI + displ16);
        if (BX_CPU_THIS_PTR segment_override)
          BX_CPU_THIS_PTR rm_seg_reg = BX_CPU_THIS_PTR segment_override;
        else
          BX_CPU_THIS_PTR rm_seg_reg = & BX_CPU_THIS_PTR ds;
        break;
      case 0x92:
        BX_CPU_THIS_PTR reg_index = 0x2;
        BX_CPU_THIS_PTR rm_type = BX_MEMORY_REF;
        displ16 = fetch_next_word();
        BX_CPU_THIS_PTR rm_addr = (Bit16u) (BP + SI + displ16);
        if (BX_CPU_THIS_PTR segment_override)
          BX_CPU_THIS_PTR rm_seg_reg = BX_CPU_THIS_PTR segment_override;
        else
          BX_CPU_THIS_PTR rm_seg_reg = & BX_CPU_THIS_PTR ss;
        break;
      case 0x93:
        BX_CPU_THIS_PTR reg_index = 0x2;
        BX_CPU_THIS_PTR rm_type = BX_MEMORY_REF;
        displ16 = fetch_next_word();
        BX_CPU_THIS_PTR rm_addr = (Bit16u) (BP + DI + displ16);
        if (BX_CPU_THIS_PTR segment_override)
          BX_CPU_THIS_PTR rm_seg_reg = BX_CPU_THIS_PTR segment_override;
        else
          BX_CPU_THIS_PTR rm_seg_reg = & BX_CPU_THIS_PTR ss;
        break;
      case 0x94:
        BX_CPU_THIS_PTR reg_index = 0x2;
        BX_CPU_THIS_PTR rm_type = BX_MEMORY_REF;
        displ16 = fetch_next_word();
        BX_CPU_THIS_PTR rm_addr = (Bit16u) (SI + displ16);
        if (BX_CPU_THIS_PTR segment_override)
          BX_CPU_THIS_PTR rm_seg_reg = BX_CPU_THIS_PTR segment_override;
        else
          BX_CPU_THIS_PTR rm_seg_reg = & BX_CPU_THIS_PTR ds;
        break;
      case 0x95:
        BX_CPU_THIS_PTR reg_index = 0x2;
        BX_CPU_THIS_PTR rm_type = BX_MEMORY_REF;
        displ16 = fetch_next_word();
        BX_CPU_THIS_PTR rm_addr = (Bit16u) (DI + displ16);
        if (BX_CPU_THIS_PTR segment_override)
          BX_CPU_THIS_PTR rm_seg_reg = BX_CPU_THIS_PTR segment_override;
        else
          BX_CPU_THIS_PTR rm_seg_reg = & BX_CPU_THIS_PTR ds;
        break;
      case 0x96:
        BX_CPU_THIS_PTR reg_index = 0x2;
        BX_CPU_THIS_PTR rm_type = BX_MEMORY_REF;
        displ16 = fetch_next_word();
        BX_CPU_THIS_PTR rm_addr = (Bit16u) (BP + displ16);
        if (BX_CPU_THIS_PTR segment_override)
          BX_CPU_THIS_PTR rm_seg_reg = BX_CPU_THIS_PTR segment_override;
        else
          BX_CPU_THIS_PTR rm_seg_reg = & BX_CPU_THIS_PTR ss;
        break;
      case 0x97:
        BX_CPU_THIS_PTR reg_index = 0x2;
        BX_CPU_THIS_PTR rm_type = BX_MEMORY_REF;
        displ16 = fetch_next_word();
        BX_CPU_THIS_PTR rm_addr = (Bit16u) (BX + displ16);
        if (BX_CPU_THIS_PTR segment_override)
          BX_CPU_THIS_PTR rm_seg_reg = BX_CPU_THIS_PTR segment_override;
        else
          BX_CPU_THIS_PTR rm_seg_reg = & BX_CPU_THIS_PTR ds;
        break;
      case 0x98:
        BX_CPU_THIS_PTR reg_index = 0x3;
        BX_CPU_THIS_PTR rm_type = BX_MEMORY_REF;
        displ16 = fetch_next_word();
        BX_CPU_THIS_PTR rm_addr = (Bit16u) (BX + SI + displ16);
        if (BX_CPU_THIS_PTR segment_override)
          BX_CPU_THIS_PTR rm_seg_reg = BX_CPU_THIS_PTR segment_override;
        else
          BX_CPU_THIS_PTR rm_seg_reg = & BX_CPU_THIS_PTR ds;
        break;
      case 0x99:
        BX_CPU_THIS_PTR reg_index = 0x3;
        BX_CPU_THIS_PTR rm_type = BX_MEMORY_REF;
        displ16 = fetch_next_word();
        BX_CPU_THIS_PTR rm_addr = (Bit16u) (BX + DI + displ16);
        if (BX_CPU_THIS_PTR segment_override)
          BX_CPU_THIS_PTR rm_seg_reg = BX_CPU_THIS_PTR segment_override;
        else
          BX_CPU_THIS_PTR rm_seg_reg = & BX_CPU_THIS_PTR ds;
        break;
      case 0x9a:
        BX_CPU_THIS_PTR reg_index = 0x3;
        BX_CPU_THIS_PTR rm_type = BX_MEMORY_REF;
        displ16 = fetch_next_word();
        BX_CPU_THIS_PTR rm_addr = (Bit16u) (BP + SI + displ16);
        if (BX_CPU_THIS_PTR segment_override)
          BX_CPU_THIS_PTR rm_seg_reg = BX_CPU_THIS_PTR segment_override;
        else
          BX_CPU_THIS_PTR rm_seg_reg = & BX_CPU_THIS_PTR ss;
        break;
      case 0x9b:
        BX_CPU_THIS_PTR reg_index = 0x3;
        BX_CPU_THIS_PTR rm_type = BX_MEMORY_REF;
        displ16 = fetch_next_word();
        BX_CPU_THIS_PTR rm_addr = (Bit16u) (BP + DI + displ16);
        if (BX_CPU_THIS_PTR segment_override)
          BX_CPU_THIS_PTR rm_seg_reg = BX_CPU_THIS_PTR segment_override;
        else
          BX_CPU_THIS_PTR rm_seg_reg = & BX_CPU_THIS_PTR ss;
        break;
      case 0x9c:
        BX_CPU_THIS_PTR reg_index = 0x3;
        BX_CPU_THIS_PTR rm_type = BX_MEMORY_REF;
        displ16 = fetch_next_word();
        BX_CPU_THIS_PTR rm_addr = (Bit16u) (SI + displ16);
        if (BX_CPU_THIS_PTR segment_override)
          BX_CPU_THIS_PTR rm_seg_reg = BX_CPU_THIS_PTR segment_override;
        else
          BX_CPU_THIS_PTR rm_seg_reg = & BX_CPU_THIS_PTR ds;
        break;
      case 0x9d:
        BX_CPU_THIS_PTR reg_index = 0x3;
        BX_CPU_THIS_PTR rm_type = BX_MEMORY_REF;
        displ16 = fetch_next_word();
        BX_CPU_THIS_PTR rm_addr = (Bit16u) (DI + displ16);
        if (BX_CPU_THIS_PTR segment_override)
          BX_CPU_THIS_PTR rm_seg_reg = BX_CPU_THIS_PTR segment_override;
        else
          BX_CPU_THIS_PTR rm_seg_reg = & BX_CPU_THIS_PTR ds;
        break;
      case 0x9e:
        BX_CPU_THIS_PTR reg_index = 0x3;
        BX_CPU_THIS_PTR rm_type = BX_MEMORY_REF;
        displ16 = fetch_next_word();
        BX_CPU_THIS_PTR rm_addr = (Bit16u) (BP + displ16);
        if (BX_CPU_THIS_PTR segment_override)
          BX_CPU_THIS_PTR rm_seg_reg = BX_CPU_THIS_PTR segment_override;
        else
          BX_CPU_THIS_PTR rm_seg_reg = & BX_CPU_THIS_PTR ss;
        break;
      case 0x9f:
        BX_CPU_THIS_PTR reg_index = 0x3;
        BX_CPU_THIS_PTR rm_type = BX_MEMORY_REF;
        displ16 = fetch_next_word();
        BX_CPU_THIS_PTR rm_addr = (Bit16u) (BX + displ16);
        if (BX_CPU_THIS_PTR segment_override)
          BX_CPU_THIS_PTR rm_seg_reg = BX_CPU_THIS_PTR segment_override;
        else
          BX_CPU_THIS_PTR rm_seg_reg = & BX_CPU_THIS_PTR ds;
        break;
      case 0xa0:
        BX_CPU_THIS_PTR reg_index = 0x4;
        BX_CPU_THIS_PTR rm_type = BX_MEMORY_REF;
        displ16 = fetch_next_word();
        BX_CPU_THIS_PTR rm_addr = (Bit16u) (BX + SI + displ16);
        if (BX_CPU_THIS_PTR segment_override)
          BX_CPU_THIS_PTR rm_seg_reg = BX_CPU_THIS_PTR segment_override;
        else
          BX_CPU_THIS_PTR rm_seg_reg = & BX_CPU_THIS_PTR ds;
        break;
      case 0xa1:
        BX_CPU_THIS_PTR reg_index = 0x4;
        BX_CPU_THIS_PTR rm_type = BX_MEMORY_REF;
        displ16 = fetch_next_word();
        BX_CPU_THIS_PTR rm_addr = (Bit16u) (BX + DI + displ16);
        if (BX_CPU_THIS_PTR segment_override)
          BX_CPU_THIS_PTR rm_seg_reg = BX_CPU_THIS_PTR segment_override;
        else
          BX_CPU_THIS_PTR rm_seg_reg = & BX_CPU_THIS_PTR ds;
        break;
      case 0xa2:
        BX_CPU_THIS_PTR reg_index = 0x4;
        BX_CPU_THIS_PTR rm_type = BX_MEMORY_REF;
        displ16 = fetch_next_word();
        BX_CPU_THIS_PTR rm_addr = (Bit16u) (BP + SI + displ16);
        if (BX_CPU_THIS_PTR segment_override)
          BX_CPU_THIS_PTR rm_seg_reg = BX_CPU_THIS_PTR segment_override;
        else
          BX_CPU_THIS_PTR rm_seg_reg = & BX_CPU_THIS_PTR ss;
        break;
      case 0xa3:
        BX_CPU_THIS_PTR reg_index = 0x4;
        BX_CPU_THIS_PTR rm_type = BX_MEMORY_REF;
        displ16 = fetch_next_word();
        BX_CPU_THIS_PTR rm_addr = (Bit16u) (BP + DI + displ16);
        if (BX_CPU_THIS_PTR segment_override)
          BX_CPU_THIS_PTR rm_seg_reg = BX_CPU_THIS_PTR segment_override;
        else
          BX_CPU_THIS_PTR rm_seg_reg = & BX_CPU_THIS_PTR ss;
        break;
      case 0xa4:
        BX_CPU_THIS_PTR reg_index = 0x4;
        BX_CPU_THIS_PTR rm_type = BX_MEMORY_REF;
        displ16 = fetch_next_word();
        BX_CPU_THIS_PTR rm_addr = (Bit16u) (SI + displ16);
        if (BX_CPU_THIS_PTR segment_override)
          BX_CPU_THIS_PTR rm_seg_reg = BX_CPU_THIS_PTR segment_override;
        else
          BX_CPU_THIS_PTR rm_seg_reg = & BX_CPU_THIS_PTR ds;
        break;
      case 0xa5:
        BX_CPU_THIS_PTR reg_index = 0x4;
        BX_CPU_THIS_PTR rm_type = BX_MEMORY_REF;
        displ16 = fetch_next_word();
        BX_CPU_THIS_PTR rm_addr = (Bit16u) (DI + displ16);
        if (BX_CPU_THIS_PTR segment_override)
          BX_CPU_THIS_PTR rm_seg_reg = BX_CPU_THIS_PTR segment_override;
        else
          BX_CPU_THIS_PTR rm_seg_reg = & BX_CPU_THIS_PTR ds;
        break;
      case 0xa6:
        BX_CPU_THIS_PTR reg_index = 0x4;
        BX_CPU_THIS_PTR rm_type = BX_MEMORY_REF;
        displ16 = fetch_next_word();
        BX_CPU_THIS_PTR rm_addr = (Bit16u) (BP + displ16);
        if (BX_CPU_THIS_PTR segment_override)
          BX_CPU_THIS_PTR rm_seg_reg = BX_CPU_THIS_PTR segment_override;
        else
          BX_CPU_THIS_PTR rm_seg_reg = & BX_CPU_THIS_PTR ss;
        break;
      case 0xa7:
        BX_CPU_THIS_PTR reg_index = 0x4;
        BX_CPU_THIS_PTR rm_type = BX_MEMORY_REF;
        displ16 = fetch_next_word();
        BX_CPU_THIS_PTR rm_addr = (Bit16u) (BX + displ16);
        if (BX_CPU_THIS_PTR segment_override)
          BX_CPU_THIS_PTR rm_seg_reg = BX_CPU_THIS_PTR segment_override;
        else
          BX_CPU_THIS_PTR rm_seg_reg = & BX_CPU_THIS_PTR ds;
        break;
      case 0xa8:
        BX_CPU_THIS_PTR reg_index = 0x5;
        BX_CPU_THIS_PTR rm_type = BX_MEMORY_REF;
        displ16 = fetch_next_word();
        BX_CPU_THIS_PTR rm_addr = (Bit16u) (BX + SI + displ16);
        if (BX_CPU_THIS_PTR segment_override)
          BX_CPU_THIS_PTR rm_seg_reg = BX_CPU_THIS_PTR segment_override;
        else
          BX_CPU_THIS_PTR rm_seg_reg = & BX_CPU_THIS_PTR ds;
        break;
      case 0xa9:
        BX_CPU_THIS_PTR reg_index = 0x5;
        BX_CPU_THIS_PTR rm_type = BX_MEMORY_REF;
        displ16 = fetch_next_word();
        BX_CPU_THIS_PTR rm_addr = (Bit16u) (BX + DI + displ16);
        if (BX_CPU_THIS_PTR segment_override)
          BX_CPU_THIS_PTR rm_seg_reg = BX_CPU_THIS_PTR segment_override;
        else
          BX_CPU_THIS_PTR rm_seg_reg = & BX_CPU_THIS_PTR ds;
        break;
      case 0xaa:
        BX_CPU_THIS_PTR reg_index = 0x5;
        BX_CPU_THIS_PTR rm_type = BX_MEMORY_REF;
        displ16 = fetch_next_word();
        BX_CPU_THIS_PTR rm_addr = (Bit16u) (BP + SI + displ16);
        if (BX_CPU_THIS_PTR segment_override)
          BX_CPU_THIS_PTR rm_seg_reg = BX_CPU_THIS_PTR segment_override;
        else
          BX_CPU_THIS_PTR rm_seg_reg = & BX_CPU_THIS_PTR ss;
        break;
      case 0xab:
        BX_CPU_THIS_PTR reg_index = 0x5;
        BX_CPU_THIS_PTR rm_type = BX_MEMORY_REF;
        displ16 = fetch_next_word();
        BX_CPU_THIS_PTR rm_addr = (Bit16u) (BP + DI + displ16);
        if (BX_CPU_THIS_PTR segment_override)
          BX_CPU_THIS_PTR rm_seg_reg = BX_CPU_THIS_PTR segment_override;
        else
          BX_CPU_THIS_PTR rm_seg_reg = & BX_CPU_THIS_PTR ss;
        break;
      case 0xac:
        BX_CPU_THIS_PTR reg_index = 0x5;
        BX_CPU_THIS_PTR rm_type = BX_MEMORY_REF;
        displ16 = fetch_next_word();
        BX_CPU_THIS_PTR rm_addr = (Bit16u) (SI + displ16);
        if (BX_CPU_THIS_PTR segment_override)
          BX_CPU_THIS_PTR rm_seg_reg = BX_CPU_THIS_PTR segment_override;
        else
          BX_CPU_THIS_PTR rm_seg_reg = & BX_CPU_THIS_PTR ds;
        break;
      case 0xad:
        BX_CPU_THIS_PTR reg_index = 0x5;
        BX_CPU_THIS_PTR rm_type = BX_MEMORY_REF;
        displ16 = fetch_next_word();
        BX_CPU_THIS_PTR rm_addr = (Bit16u) (DI + displ16);
        if (BX_CPU_THIS_PTR segment_override)
          BX_CPU_THIS_PTR rm_seg_reg = BX_CPU_THIS_PTR segment_override;
        else
          BX_CPU_THIS_PTR rm_seg_reg = & BX_CPU_THIS_PTR ds;
        break;
      case 0xae:
        BX_CPU_THIS_PTR reg_index = 0x5;
        BX_CPU_THIS_PTR rm_type = BX_MEMORY_REF;
        displ16 = fetch_next_word();
        BX_CPU_THIS_PTR rm_addr = (Bit16u) (BP + displ16);
        if (BX_CPU_THIS_PTR segment_override)
          BX_CPU_THIS_PTR rm_seg_reg = BX_CPU_THIS_PTR segment_override;
        else
          BX_CPU_THIS_PTR rm_seg_reg = & BX_CPU_THIS_PTR ss;
        break;
      case 0xaf:
        BX_CPU_THIS_PTR reg_index = 0x5;
        BX_CPU_THIS_PTR rm_type = BX_MEMORY_REF;
        displ16 = fetch_next_word();
        BX_CPU_THIS_PTR rm_addr = (Bit16u) (BX + displ16);
        if (BX_CPU_THIS_PTR segment_override)
          BX_CPU_THIS_PTR rm_seg_reg = BX_CPU_THIS_PTR segment_override;
        else
          BX_CPU_THIS_PTR rm_seg_reg = & BX_CPU_THIS_PTR ds;
        break;
      case 0xb0:
        BX_CPU_THIS_PTR reg_index = 0x6;
        BX_CPU_THIS_PTR rm_type = BX_MEMORY_REF;
        displ16 = fetch_next_word();
        BX_CPU_THIS_PTR rm_addr = (Bit16u) (BX + SI + displ16);
        if (BX_CPU_THIS_PTR segment_override)
          BX_CPU_THIS_PTR rm_seg_reg = BX_CPU_THIS_PTR segment_override;
        else
          BX_CPU_THIS_PTR rm_seg_reg = & BX_CPU_THIS_PTR ds;
        break;
      case 0xb1:
        BX_CPU_THIS_PTR reg_index = 0x6;
        BX_CPU_THIS_PTR rm_type = BX_MEMORY_REF;
        displ16 = fetch_next_word();
        BX_CPU_THIS_PTR rm_addr = (Bit16u) (BX + DI + displ16);
        if (BX_CPU_THIS_PTR segment_override)
          BX_CPU_THIS_PTR rm_seg_reg = BX_CPU_THIS_PTR segment_override;
        else
          BX_CPU_THIS_PTR rm_seg_reg = & BX_CPU_THIS_PTR ds;
        break;
      case 0xb2:
        BX_CPU_THIS_PTR reg_index = 0x6;
        BX_CPU_THIS_PTR rm_type = BX_MEMORY_REF;
        displ16 = fetch_next_word();
        BX_CPU_THIS_PTR rm_addr = (Bit16u) (BP + SI + displ16);
        if (BX_CPU_THIS_PTR segment_override)
          BX_CPU_THIS_PTR rm_seg_reg = BX_CPU_THIS_PTR segment_override;
        else
          BX_CPU_THIS_PTR rm_seg_reg = & BX_CPU_THIS_PTR ss;
        break;
      case 0xb3:
        BX_CPU_THIS_PTR reg_index = 0x6;
        BX_CPU_THIS_PTR rm_type = BX_MEMORY_REF;
        displ16 = fetch_next_word();
        BX_CPU_THIS_PTR rm_addr = (Bit16u) (BP + DI + displ16);
        if (BX_CPU_THIS_PTR segment_override)
          BX_CPU_THIS_PTR rm_seg_reg = BX_CPU_THIS_PTR segment_override;
        else
          BX_CPU_THIS_PTR rm_seg_reg = & BX_CPU_THIS_PTR ss;
        break;
      case 0xb4:
        BX_CPU_THIS_PTR reg_index = 0x6;
        BX_CPU_THIS_PTR rm_type = BX_MEMORY_REF;
        displ16 = fetch_next_word();
        BX_CPU_THIS_PTR rm_addr = (Bit16u) (SI + displ16);
        if (BX_CPU_THIS_PTR segment_override)
          BX_CPU_THIS_PTR rm_seg_reg = BX_CPU_THIS_PTR segment_override;
        else
          BX_CPU_THIS_PTR rm_seg_reg = & BX_CPU_THIS_PTR ds;
        break;
      case 0xb5:
        BX_CPU_THIS_PTR reg_index = 0x6;
        BX_CPU_THIS_PTR rm_type = BX_MEMORY_REF;
        displ16 = fetch_next_word();
        BX_CPU_THIS_PTR rm_addr = (Bit16u) (DI + displ16);
        if (BX_CPU_THIS_PTR segment_override)
          BX_CPU_THIS_PTR rm_seg_reg = BX_CPU_THIS_PTR segment_override;
        else
          BX_CPU_THIS_PTR rm_seg_reg = & BX_CPU_THIS_PTR ds;
        break;
      case 0xb6:
        BX_CPU_THIS_PTR reg_index = 0x6;
        BX_CPU_THIS_PTR rm_type = BX_MEMORY_REF;
        displ16 = fetch_next_word();
        BX_CPU_THIS_PTR rm_addr = (Bit16u) (BP + displ16);
        if (BX_CPU_THIS_PTR segment_override)
          BX_CPU_THIS_PTR rm_seg_reg = BX_CPU_THIS_PTR segment_override;
        else
          BX_CPU_THIS_PTR rm_seg_reg = & BX_CPU_THIS_PTR ss;
        break;
      case 0xb7:
        BX_CPU_THIS_PTR reg_index = 0x6;
        BX_CPU_THIS_PTR rm_type = BX_MEMORY_REF;
        displ16 = fetch_next_word();
        BX_CPU_THIS_PTR rm_addr = (Bit16u) (BX + displ16);
        if (BX_CPU_THIS_PTR segment_override)
          BX_CPU_THIS_PTR rm_seg_reg = BX_CPU_THIS_PTR segment_override;
        else
          BX_CPU_THIS_PTR rm_seg_reg = & BX_CPU_THIS_PTR ds;
        break;
      case 0xb8:
        BX_CPU_THIS_PTR reg_index = 0x7;
        BX_CPU_THIS_PTR rm_type = BX_MEMORY_REF;
        displ16 = fetch_next_word();
        BX_CPU_THIS_PTR rm_addr = (Bit16u) (BX + SI + displ16);
        if (BX_CPU_THIS_PTR segment_override)
          BX_CPU_THIS_PTR rm_seg_reg = BX_CPU_THIS_PTR segment_override;
        else
          BX_CPU_THIS_PTR rm_seg_reg = & BX_CPU_THIS_PTR ds;
        break;
      case 0xb9:
        BX_CPU_THIS_PTR reg_index = 0x7;
        BX_CPU_THIS_PTR rm_type = BX_MEMORY_REF;
        displ16 = fetch_next_word();
        BX_CPU_THIS_PTR rm_addr = (Bit16u) (BX + DI + displ16);
        if (BX_CPU_THIS_PTR segment_override)
          BX_CPU_THIS_PTR rm_seg_reg = BX_CPU_THIS_PTR segment_override;
        else
          BX_CPU_THIS_PTR rm_seg_reg = & BX_CPU_THIS_PTR ds;
        break;
      case 0xba:
        BX_CPU_THIS_PTR reg_index = 0x7;
        BX_CPU_THIS_PTR rm_type = BX_MEMORY_REF;
        displ16 = fetch_next_word();
        BX_CPU_THIS_PTR rm_addr = (Bit16u) (BP + SI + displ16);
        if (BX_CPU_THIS_PTR segment_override)
          BX_CPU_THIS_PTR rm_seg_reg = BX_CPU_THIS_PTR segment_override;
        else
          BX_CPU_THIS_PTR rm_seg_reg = & BX_CPU_THIS_PTR ss;
        break;
      case 0xbb:
        BX_CPU_THIS_PTR reg_index = 0x7;
        BX_CPU_THIS_PTR rm_type = BX_MEMORY_REF;
        displ16 = fetch_next_word();
        BX_CPU_THIS_PTR rm_addr = (Bit16u) (BP + DI + displ16);
        if (BX_CPU_THIS_PTR segment_override)
          BX_CPU_THIS_PTR rm_seg_reg = BX_CPU_THIS_PTR segment_override;
        else
          BX_CPU_THIS_PTR rm_seg_reg = & BX_CPU_THIS_PTR ss;
        break;
      case 0xbc:
        BX_CPU_THIS_PTR reg_index = 0x7;
        BX_CPU_THIS_PTR rm_type = BX_MEMORY_REF;
        displ16 = fetch_next_word();
        BX_CPU_THIS_PTR rm_addr = (Bit16u) (SI + displ16);
        if (BX_CPU_THIS_PTR segment_override)
          BX_CPU_THIS_PTR rm_seg_reg = BX_CPU_THIS_PTR segment_override;
        else
          BX_CPU_THIS_PTR rm_seg_reg = & BX_CPU_THIS_PTR ds;
        break;
      case 0xbd:
        BX_CPU_THIS_PTR reg_index = 0x7;
        BX_CPU_THIS_PTR rm_type = BX_MEMORY_REF;
        displ16 = fetch_next_word();
        BX_CPU_THIS_PTR rm_addr = (Bit16u) (DI + displ16);
        if (BX_CPU_THIS_PTR segment_override)
          BX_CPU_THIS_PTR rm_seg_reg = BX_CPU_THIS_PTR segment_override;
        else
          BX_CPU_THIS_PTR rm_seg_reg = & BX_CPU_THIS_PTR ds;
        break;
      case 0xbe:
        BX_CPU_THIS_PTR reg_index = 0x7;
        BX_CPU_THIS_PTR rm_type = BX_MEMORY_REF;
        displ16 = fetch_next_word();
        BX_CPU_THIS_PTR rm_addr = (Bit16u) (BP + displ16);
        if (BX_CPU_THIS_PTR segment_override)
          BX_CPU_THIS_PTR rm_seg_reg = BX_CPU_THIS_PTR segment_override;
        else
          BX_CPU_THIS_PTR rm_seg_reg = & BX_CPU_THIS_PTR ss;
        break;
      case 0xbf:
        BX_CPU_THIS_PTR reg_index = 0x7;
        BX_CPU_THIS_PTR rm_type = BX_MEMORY_REF;
        displ16 = fetch_next_word();
        BX_CPU_THIS_PTR rm_addr = (Bit16u) (BX + displ16);
        if (BX_CPU_THIS_PTR segment_override)
          BX_CPU_THIS_PTR rm_seg_reg = BX_CPU_THIS_PTR segment_override;
        else
          BX_CPU_THIS_PTR rm_seg_reg = & BX_CPU_THIS_PTR ds;
        break;
      case 0xc0:
        BX_CPU_THIS_PTR reg_index = 0x0;
        BX_CPU_THIS_PTR rm_addr = 0x0;
        BX_CPU_THIS_PTR rm_type = BX_REGISTER_REF;
        break;
      case 0xc1:
        BX_CPU_THIS_PTR reg_index = 0x0;
        BX_CPU_THIS_PTR rm_addr = 0x1;
        BX_CPU_THIS_PTR rm_type = BX_REGISTER_REF;
        break;
      case 0xc2:
        BX_CPU_THIS_PTR reg_index = 0x0;
        BX_CPU_THIS_PTR rm_addr = 0x2;
        BX_CPU_THIS_PTR rm_type = BX_REGISTER_REF;
        break;
      case 0xc3:
        BX_CPU_THIS_PTR reg_index = 0x0;
        BX_CPU_THIS_PTR rm_addr = 0x3;
        BX_CPU_THIS_PTR rm_type = BX_REGISTER_REF;
        break;
      case 0xc4:
        BX_CPU_THIS_PTR reg_index = 0x0;
        BX_CPU_THIS_PTR rm_addr = 0x4;
        BX_CPU_THIS_PTR rm_type = BX_REGISTER_REF;
        break;
      case 0xc5:
        BX_CPU_THIS_PTR reg_index = 0x0;
        BX_CPU_THIS_PTR rm_addr = 0x5;
        BX_CPU_THIS_PTR rm_type = BX_REGISTER_REF;
        break;
      case 0xc6:
        BX_CPU_THIS_PTR reg_index = 0x0;
        BX_CPU_THIS_PTR rm_addr = 0x6;
        BX_CPU_THIS_PTR rm_type = BX_REGISTER_REF;
        break;
      case 0xc7:
        BX_CPU_THIS_PTR reg_index = 0x0;
        BX_CPU_THIS_PTR rm_addr = 0x7;
        BX_CPU_THIS_PTR rm_type = BX_REGISTER_REF;
        break;
      case 0xc8:
        BX_CPU_THIS_PTR reg_index = 0x1;
        BX_CPU_THIS_PTR rm_addr = 0x0;
        BX_CPU_THIS_PTR rm_type = BX_REGISTER_REF;
        break;
      case 0xc9:
        BX_CPU_THIS_PTR reg_index = 0x1;
        BX_CPU_THIS_PTR rm_addr = 0x1;
        BX_CPU_THIS_PTR rm_type = BX_REGISTER_REF;
        break;
      case 0xca:
        BX_CPU_THIS_PTR reg_index = 0x1;
        BX_CPU_THIS_PTR rm_addr = 0x2;
        BX_CPU_THIS_PTR rm_type = BX_REGISTER_REF;
        break;
      case 0xcb:
        BX_CPU_THIS_PTR reg_index = 0x1;
        BX_CPU_THIS_PTR rm_addr = 0x3;
        BX_CPU_THIS_PTR rm_type = BX_REGISTER_REF;
        break;
      case 0xcc:
        BX_CPU_THIS_PTR reg_index = 0x1;
        BX_CPU_THIS_PTR rm_addr = 0x4;
        BX_CPU_THIS_PTR rm_type = BX_REGISTER_REF;
        break;
      case 0xcd:
        BX_CPU_THIS_PTR reg_index = 0x1;
        BX_CPU_THIS_PTR rm_addr = 0x5;
        BX_CPU_THIS_PTR rm_type = BX_REGISTER_REF;
        break;
      case 0xce:
        BX_CPU_THIS_PTR reg_index = 0x1;
        BX_CPU_THIS_PTR rm_addr = 0x6;
        BX_CPU_THIS_PTR rm_type = BX_REGISTER_REF;
        break;
      case 0xcf:
        BX_CPU_THIS_PTR reg_index = 0x1;
        BX_CPU_THIS_PTR rm_addr = 0x7;
        BX_CPU_THIS_PTR rm_type = BX_REGISTER_REF;
        break;
      case 0xd0:
        BX_CPU_THIS_PTR reg_index = 0x2;
        BX_CPU_THIS_PTR rm_addr = 0x0;
        BX_CPU_THIS_PTR rm_type = BX_REGISTER_REF;
        break;
      case 0xd1:
        BX_CPU_THIS_PTR reg_index = 0x2;
        BX_CPU_THIS_PTR rm_addr = 0x1;
        BX_CPU_THIS_PTR rm_type = BX_REGISTER_REF;
        break;
      case 0xd2:
        BX_CPU_THIS_PTR reg_index = 0x2;
        BX_CPU_THIS_PTR rm_addr = 0x2;
        BX_CPU_THIS_PTR rm_type = BX_REGISTER_REF;
        break;
      case 0xd3:
        BX_CPU_THIS_PTR reg_index = 0x2;
        BX_CPU_THIS_PTR rm_addr = 0x3;
        BX_CPU_THIS_PTR rm_type = BX_REGISTER_REF;
        break;
      case 0xd4:
        BX_CPU_THIS_PTR reg_index = 0x2;
        BX_CPU_THIS_PTR rm_addr = 0x4;
        BX_CPU_THIS_PTR rm_type = BX_REGISTER_REF;
        break;
      case 0xd5:
        BX_CPU_THIS_PTR reg_index = 0x2;
        BX_CPU_THIS_PTR rm_addr = 0x5;
        BX_CPU_THIS_PTR rm_type = BX_REGISTER_REF;
        break;
      case 0xd6:
        BX_CPU_THIS_PTR reg_index = 0x2;
        BX_CPU_THIS_PTR rm_addr = 0x6;
        BX_CPU_THIS_PTR rm_type = BX_REGISTER_REF;
        break;
      case 0xd7:
        BX_CPU_THIS_PTR reg_index = 0x2;
        BX_CPU_THIS_PTR rm_addr = 0x7;
        BX_CPU_THIS_PTR rm_type = BX_REGISTER_REF;
        break;
      case 0xd8:
        BX_CPU_THIS_PTR reg_index = 0x3;
        BX_CPU_THIS_PTR rm_addr = 0x0;
        BX_CPU_THIS_PTR rm_type = BX_REGISTER_REF;
        break;
      case 0xd9:
        BX_CPU_THIS_PTR reg_index = 0x3;
        BX_CPU_THIS_PTR rm_addr = 0x1;
        BX_CPU_THIS_PTR rm_type = BX_REGISTER_REF;
        break;
      case 0xda:
        BX_CPU_THIS_PTR reg_index = 0x3;
        BX_CPU_THIS_PTR rm_addr = 0x2;
        BX_CPU_THIS_PTR rm_type = BX_REGISTER_REF;
        break;
      case 0xdb:
        BX_CPU_THIS_PTR reg_index = 0x3;
        BX_CPU_THIS_PTR rm_addr = 0x3;
        BX_CPU_THIS_PTR rm_type = BX_REGISTER_REF;
        break;
      case 0xdc:
        BX_CPU_THIS_PTR reg_index = 0x3;
        BX_CPU_THIS_PTR rm_addr = 0x4;
        BX_CPU_THIS_PTR rm_type = BX_REGISTER_REF;
        break;
      case 0xdd:
        BX_CPU_THIS_PTR reg_index = 0x3;
        BX_CPU_THIS_PTR rm_addr = 0x5;
        BX_CPU_THIS_PTR rm_type = BX_REGISTER_REF;
        break;
      case 0xde:
        BX_CPU_THIS_PTR reg_index = 0x3;
        BX_CPU_THIS_PTR rm_addr = 0x6;
        BX_CPU_THIS_PTR rm_type = BX_REGISTER_REF;
        break;
      case 0xdf:
        BX_CPU_THIS_PTR reg_index = 0x3;
        BX_CPU_THIS_PTR rm_addr = 0x7;
        BX_CPU_THIS_PTR rm_type = BX_REGISTER_REF;
        break;
      case 0xe0:
        BX_CPU_THIS_PTR reg_index = 0x4;
        BX_CPU_THIS_PTR rm_addr = 0x0;
        BX_CPU_THIS_PTR rm_type = BX_REGISTER_REF;
        break;
      case 0xe1:
        BX_CPU_THIS_PTR reg_index = 0x4;
        BX_CPU_THIS_PTR rm_addr = 0x1;
        BX_CPU_THIS_PTR rm_type = BX_REGISTER_REF;
        break;
      case 0xe2:
        BX_CPU_THIS_PTR reg_index = 0x4;
        BX_CPU_THIS_PTR rm_addr = 0x2;
        BX_CPU_THIS_PTR rm_type = BX_REGISTER_REF;
        break;
      case 0xe3:
        BX_CPU_THIS_PTR reg_index = 0x4;
        BX_CPU_THIS_PTR rm_addr = 0x3;
        BX_CPU_THIS_PTR rm_type = BX_REGISTER_REF;
        break;
      case 0xe4:
        BX_CPU_THIS_PTR reg_index = 0x4;
        BX_CPU_THIS_PTR rm_addr = 0x4;
        BX_CPU_THIS_PTR rm_type = BX_REGISTER_REF;
        break;
      case 0xe5:
        BX_CPU_THIS_PTR reg_index = 0x4;
        BX_CPU_THIS_PTR rm_addr = 0x5;
        BX_CPU_THIS_PTR rm_type = BX_REGISTER_REF;
        break;
      case 0xe6:
        BX_CPU_THIS_PTR reg_index = 0x4;
        BX_CPU_THIS_PTR rm_addr = 0x6;
        BX_CPU_THIS_PTR rm_type = BX_REGISTER_REF;
        break;
      case 0xe7:
        BX_CPU_THIS_PTR reg_index = 0x4;
        BX_CPU_THIS_PTR rm_addr = 0x7;
        BX_CPU_THIS_PTR rm_type = BX_REGISTER_REF;
        break;
      case 0xe8:
        BX_CPU_THIS_PTR reg_index = 0x5;
        BX_CPU_THIS_PTR rm_addr = 0x0;
        BX_CPU_THIS_PTR rm_type = BX_REGISTER_REF;
        break;
      case 0xe9:
        BX_CPU_THIS_PTR reg_index = 0x5;
        BX_CPU_THIS_PTR rm_addr = 0x1;
        BX_CPU_THIS_PTR rm_type = BX_REGISTER_REF;
        break;
      case 0xea:
        BX_CPU_THIS_PTR reg_index = 0x5;
        BX_CPU_THIS_PTR rm_addr = 0x2;
        BX_CPU_THIS_PTR rm_type = BX_REGISTER_REF;
        break;
      case 0xeb:
        BX_CPU_THIS_PTR reg_index = 0x5;
        BX_CPU_THIS_PTR rm_addr = 0x3;
        BX_CPU_THIS_PTR rm_type = BX_REGISTER_REF;
        break;
      case 0xec:
        BX_CPU_THIS_PTR reg_index = 0x5;
        BX_CPU_THIS_PTR rm_addr = 0x4;
        BX_CPU_THIS_PTR rm_type = BX_REGISTER_REF;
        break;
      case 0xed:
        BX_CPU_THIS_PTR reg_index = 0x5;
        BX_CPU_THIS_PTR rm_addr = 0x5;
        BX_CPU_THIS_PTR rm_type = BX_REGISTER_REF;
        break;
      case 0xee:
        BX_CPU_THIS_PTR reg_index = 0x5;
        BX_CPU_THIS_PTR rm_addr = 0x6;
        BX_CPU_THIS_PTR rm_type = BX_REGISTER_REF;
        break;
      case 0xef:
        BX_CPU_THIS_PTR reg_index = 0x5;
        BX_CPU_THIS_PTR rm_addr = 0x7;
        BX_CPU_THIS_PTR rm_type = BX_REGISTER_REF;
        break;
      case 0xf0:
        BX_CPU_THIS_PTR reg_index = 0x6;
        BX_CPU_THIS_PTR rm_addr = 0x0;
        BX_CPU_THIS_PTR rm_type = BX_REGISTER_REF;
        break;
      case 0xf1:
        BX_CPU_THIS_PTR reg_index = 0x6;
        BX_CPU_THIS_PTR rm_addr = 0x1;
        BX_CPU_THIS_PTR rm_type = BX_REGISTER_REF;
        break;
      case 0xf2:
        BX_CPU_THIS_PTR reg_index = 0x6;
        BX_CPU_THIS_PTR rm_addr = 0x2;
        BX_CPU_THIS_PTR rm_type = BX_REGISTER_REF;
        break;
      case 0xf3:
        BX_CPU_THIS_PTR reg_index = 0x6;
        BX_CPU_THIS_PTR rm_addr = 0x3;
        BX_CPU_THIS_PTR rm_type = BX_REGISTER_REF;
        break;
      case 0xf4:
        BX_CPU_THIS_PTR reg_index = 0x6;
        BX_CPU_THIS_PTR rm_addr = 0x4;
        BX_CPU_THIS_PTR rm_type = BX_REGISTER_REF;
        break;
      case 0xf5:
        BX_CPU_THIS_PTR reg_index = 0x6;
        BX_CPU_THIS_PTR rm_addr = 0x5;
        BX_CPU_THIS_PTR rm_type = BX_REGISTER_REF;
        break;
      case 0xf6:
        BX_CPU_THIS_PTR reg_index = 0x6;
        BX_CPU_THIS_PTR rm_addr = 0x6;
        BX_CPU_THIS_PTR rm_type = BX_REGISTER_REF;
        break;
      case 0xf7:
        BX_CPU_THIS_PTR reg_index = 0x6;
        BX_CPU_THIS_PTR rm_addr = 0x7;
        BX_CPU_THIS_PTR rm_type = BX_REGISTER_REF;
        break;
      case 0xf8:
        BX_CPU_THIS_PTR reg_index = 0x7;
        BX_CPU_THIS_PTR rm_addr = 0x0;
        BX_CPU_THIS_PTR rm_type = BX_REGISTER_REF;
        break;
      case 0xf9:
        BX_CPU_THIS_PTR reg_index = 0x7;
        BX_CPU_THIS_PTR rm_addr = 0x1;
        BX_CPU_THIS_PTR rm_type = BX_REGISTER_REF;
        break;
      case 0xfa:
        BX_CPU_THIS_PTR reg_index = 0x7;
        BX_CPU_THIS_PTR rm_addr = 0x2;
        BX_CPU_THIS_PTR rm_type = BX_REGISTER_REF;
        break;
      case 0xfb:
        BX_CPU_THIS_PTR reg_index = 0x7;
        BX_CPU_THIS_PTR rm_addr = 0x3;
        BX_CPU_THIS_PTR rm_type = BX_REGISTER_REF;
        break;
      case 0xfc:
        BX_CPU_THIS_PTR reg_index = 0x7;
        BX_CPU_THIS_PTR rm_addr = 0x4;
        BX_CPU_THIS_PTR rm_type = BX_REGISTER_REF;
        break;
      case 0xfd:
        BX_CPU_THIS_PTR reg_index = 0x7;
        BX_CPU_THIS_PTR rm_addr = 0x5;
        BX_CPU_THIS_PTR rm_type = BX_REGISTER_REF;
        break;
      case 0xfe:
        BX_CPU_THIS_PTR reg_index = 0x7;
        BX_CPU_THIS_PTR rm_addr = 0x6;
        BX_CPU_THIS_PTR rm_type = BX_REGISTER_REF;
        break;
      case 0xff:
        BX_CPU_THIS_PTR reg_index = 0x7;
        BX_CPU_THIS_PTR rm_addr = 0x7;
        BX_CPU_THIS_PTR rm_type = BX_REGISTER_REF;
        break;
      }
    } /* else ... */
}

  void
bx_cpu_c::decode_ESC_modrm(void)
{
  unsigned modrm;

  modrm = fetch_next_byte();
  BX_CPU_THIS_PTR ESC_modrm = modrm;
  BX_CPU_THIS_PTR ESC_rm    = modrm & 0x07; modrm >>= 3;
  BX_CPU_THIS_PTR ESC_nnn   = modrm & 0x07; modrm >>= 3;
  BX_CPU_THIS_PTR ESC_mod   = modrm;
}
