// Copyright Notice
// ================
// BOCHS is Copyright 1994,1995,1996,1997,1998 by Kevin P. Lawton.
// 
// BOCHS is commercial software.
// 
// For more information, read the file 'LICENSE' included in the bochs
// distribution.  If you don't have access to this file, or have questions
// regarding the licensing policy, the author may be contacted via:
// 
//     US Mail:  Kevin Lawton
//               528 Lexington St.
//               Waltham, MA 02154
// 
//     EMail:    bochs@world.std.com







#include "bochs.h"




  void
bx_cpu_c::enter_protected_mode(void)
{
// bx_printf("processor switching into PROTECTED mode!!!\n");
// debug(BX_CPU_THIS_PTR prev_eip);
  if (v8086_mode()) bx_panic("protect_ctrl: v8086 mode unsupported\n");

  if (bx_dbg.reset || bx_dbg._protected)
    bx_printf("processor switching into PROTECTED mode!!!\n");
  BX_CPU_THIS_PTR cr0.pe = 1;

#if 0
/* ??? */
  /* Execution in protected mode begins with a CPL of 0 */
  cs.selector.rpl = 0;
  ss.selector.rpl = 0;
#endif
if ( BX_CPU_THIS_PTR cs.selector.rpl!=0 || BX_CPU_THIS_PTR ss.selector.rpl!=0 )
  bx_panic("enter_protected_mode: CS or SS rpl != 0\n");

#if 0
  /* ??? */
  if (eflags.iopl != 0)
    bx_printf("enter_protected_mode: IOPL(%u) not 0\n",
      (unsigned) IOPL);
#endif
}


  void
bx_cpu_c::enter_real_mode(void)
{
// ???
// bx_printf("processor switching into REAL mode!!!\n");
// debug(BX_CPU_THIS_PTR prev_eip);
  if (v8086_mode()) bx_panic("protect_ctrl: v8086 mode unsupported\n");

  if (bx_dbg.reset || bx_dbg._protected)
    bx_printf("processor switching into REAL mode!!!\n");
  BX_CPU_THIS_PTR cr0.pe = 0;

#if 0
  cs.selector.rpl = 0;
  /* ??? other values set here.  Look at _Protected Mode Basics_ article */
#endif
if ( BX_CPU_THIS_PTR cs.selector.rpl!=0 || BX_CPU_THIS_PTR ss.selector.rpl!=0 )
  bx_panic("enter_real_mode: CS or SS rpl != 0\n");
}
