// Copyright Notice
// ================
// BOCHS is Copyright 1994,1995,1996,1997,1998 by Kevin P. Lawton.
//
// BOCHS is commercial software.
//
// For more information, read the file 'LICENSE' included in the bochs
// distribution.  If you don't have access to this file, or have questions
// regarding the licensing policy, the author may be contacted via:
//
//     US Mail:  Kevin Lawton
//               528 Lexington St.
//               Waltham, MA 02154
//
//     EMail:    bochs@world.std.com



#define BX_USE_MEM_SMF 1

#if BX_USE_MEM_SMF
#  define BX_MEM_SMF  static
#  define BX_MEM_THIS bx_mem.
#else
#  define BX_MEM_SMF
#  define BX_MEM_THIS this->
#endif
 
 

class bx_memory_c {

public:
  Bit8u   *vector;
  size_t  len;
  size_t  megabytes;  // (len in Megabytes)

  bx_memory_c(void);
  bx_memory_c(size_t memsize);
  ~bx_memory_c(void);
  BX_MEM_SMF void    init_memory(int memsize);
  BX_MEM_SMF void    read_physical(Bit32u addr, unsigned len, void *data);
  BX_MEM_SMF void    write_physical(Bit32u addr, unsigned len, void *data);
  BX_MEM_SMF void    load_ROM(const char *path, Bit32u romaddress);
  BX_MEM_SMF Bit32u  get_memory_in_k(void);
  };

#if BX_PROVIDE_CPU_MEMORY==1
extern bx_memory_c    bx_mem;
#endif

